﻿
Imports System
Imports System.Windows.Forms
Imports System.Security.Permissions
Imports System.IO, System.Net, System.Text


<PermissionSet(SecurityAction.Demand, Name:="FullTrust")> _
Public Class Form1
    Public WebStatus As String = "Idle" ' Photon, Logger, Minutenwerte

    Public Structure Solaranlage
        Public PVLogNummer As Integer
        Public Anlagenleistung As Double
        Public Tagesertrag() As Double
        Public Monatsertrag() As Double
        Public MonatsertragVorjahr() As Double
        Public Minutenertrag() As Double
        Public Aktualisierungsstand As Date
        Public Jahressollertrag As Double
        Public Jahr As Integer
        Public Monat As Integer
    End Structure
    Public PV1 As Solaranlage '51
    Public PV2 As Solaranlage '154
    Public PV3 As Solaranlage '177

    Public Status As String = ""
    Public Durchlauf1 As Boolean = True
    Public Daten As String
    Public Minutenvergleich(288) As Double
    Public DatenfileFehlt As Boolean
    Public nfy As New NotifyIcon
    Public NotifyWerte(10) As Double
    Public verteil() As Double = {3.01, 3.46, 5.74, 12.31, 13.76, 14.22, 13.76, 14.86, 9.39, 4.83, 2.64, 2.01}
    Public IstWertError As Boolean
    Public Structure Korrekturwerte
        Public t As Integer
        Public m As Integer
        Public j As Integer
        Public a As String
        Public w As Double
    End Structure
    Public kw() As Korrekturwerte
    Public kwAZ As Integer

    Public arguments As String()
    Public argument As String
    Public Datenkonsistenz(3, 12) As Integer '0 ist zu klein, 1 ist ok, 2 ist zu groß
    Public Zaehlerheute_h As Double
    Public Zaehlerheute_I1 As Double
    Public ms1 As Double
    Public loggerstand_changed As Boolean = False
    Public Anlage As Integer


    Private Sub refreshButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles refreshButton.Click
        If WebStatus = "Idle" Then
            WebStatus = "Photon"
            Status = "Datenabruf. Bitte warten."
            statusBox.Text = Status
            statusBox.Refresh()
            refreshButton.Enabled = False

            PV1.Jahr = CInt(Val(yearBox.Text))
            PV1.Monat = CInt(Val(monthBox.Text))
            PV2.Jahr = PV1.Jahr
            PV3.Jahr = PV1.Jahr
            PV2.Monat = PV1.Monat
            PV3.Monat = PV1.Monat


            If CB_L1PVLogEinlesen.Checked Then
                getFromPVLog(PV1.PVLogNummer, PV1.PVLogNummer)
            End If
            ' hier einlesen
            If CB_L1FreeSolEinlesen.Checked Then
                Select Case CB_L1_Quelle.SelectedIndex ' JAU 09.01.2013
                    Case 0 'S0 Impulse
                        getFromFreeSol(TB_L1FreeSolURL.Text & "/days_hist.js", PV1.PVLogNummer, False)
                    Case 1 'SML 1.8.0
                        getFromFreeSol(TB_L1FreeSolURL.Text & "/" & TextBox1.Text & "_bt.js", PV1.PVLogNummer, True)
                    Case Else 'SML 2.8.0
                        getFromFreeSol(TB_L1FreeSolURL.Text & "/" & TextBox1.Text & "_et.js", PV1.PVLogNummer, True)
                End Select
            End If
            If CB_L2FreeSolEinlesen.Checked Then
                Select Case CB_L2_Quelle.SelectedIndex ' JAU 09.01.2013
                    Case 0 'S0 Impulse
                        getFromFreeSol(TB_L2FreeSolURL.Text & "/days_hist.js", PV1.PVLogNummer, False)
                    Case 1 'SML 1.8.0
                        getFromFreeSol(TB_L2FreeSolURL.Text & "/" & TextBox1.Text & "_bt.js", PV2.PVLogNummer, True)
                    Case Else 'SML 2.8.0
                        getFromFreeSol(TB_L2FreeSolURL.Text & "/" & TextBox1.Text & "_et.js", PV2.PVLogNummer, True)
                End Select
            End If
            If CB_L3FreeSolEinlesen.Checked Then
                Select Case CB_L3_Quelle.SelectedIndex ' JAU 09.01.2013
                    Case 0 'S0 Impulse
                        getFromFreeSol(TB_L3FreeSolURL.Text & "/days_hist.js", PV3.PVLogNummer, False)
                    Case 1 'SML 1.8.0
                        getFromFreeSol(TB_L3FreeSolURL.Text & "/" & TextBox1.Text & "_bt.js", PV3.PVLogNummer, True)
                    Case Else 'SML 2.8.0
                        getFromFreeSol(TB_L3FreeSolURL.Text & "/" & TextBox1.Text & "_et.js", PV3.PVLogNummer, True)
                End Select
            End If

            Status = "Datendownload erfolgreich."
            WebStatus = "Idle"
            statusBox.Text = Status
            Datenkorrektur()
            MonatswerteFilesAktualisieren()
            Grafikaktualisierung()
            MonatswerteFilesAktualisieren()
            Grafikaktualisierung()
            TabControl1.SelectTab(0)
            refreshButton.Enabled = True
            Label11.Text = Now.ToString
        End If
    End Sub

    Private Sub MonatswerteFilesAktualisieren()
        Dim fileending = "_" & PV1.Jahr.ToString & "_0_0_m.txt"
        Dim filename As String

        If File.Exists(saveLocation.Text & "PVL_" & PV1.PVLogNummer & fileending) Then
            PV1.Monatsertrag = readFileToArray("PVL_" & PV1.PVLogNummer & fileending, 13, 0, 2)
        Else
            For i = 1 To 12
                PV1.Monatsertrag(i) = 0
            Next
        End If
        PV1.Monatsertrag(PV1.Monat) = 0
        For i = 1 To 31
            PV1.Monatsertrag(PV1.Monat) += PV1.Tagesertrag(i)
        Next

        ' Monatsfile schreiben
        filename = "PVL_" & PV1.PVLogNummer & "_" & PV1.Jahr & "_0_0_m.txt"

        File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
Solaranlage
--------------------------------------------------------------------------------------------------------
Tag; Monat; Jahr; Einspeisung in kWh

]]></a>.Value)
        For i = 1 To 12
            File.AppendAllText(saveLocation.Text & filename, i.ToString & "; " & PV1.Jahr.ToString & "; " & PV1.Monatsertrag(i).ToString & Environment.NewLine)
        Next




        If File.Exists(saveLocation.Text & "PVL_" & PV2.PVLogNummer & fileending) Then
            PV2.Monatsertrag = readFileToArray("PVL_" & PV2.PVLogNummer & fileending, 13, 0, 2)
        Else
            For i = 1 To 12
                PV2.Monatsertrag(i) = 0
            Next
        End If
        PV2.Monatsertrag(PV2.Monat) = 0
        For i = 1 To 31
            PV2.Monatsertrag(PV2.Monat) += PV2.Tagesertrag(i)
        Next

        ' Monatsfile schreiben
        filename = "PVL_" & PV2.PVLogNummer & "_" & PV2.Jahr & "_0_0_m.txt"

        File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
Solaranlage
--------------------------------------------------------------------------------------------------------
Tag; Monat; Jahr; Einspeisung in kWh

]]></a>.Value)
        For i = 1 To 12
            File.AppendAllText(saveLocation.Text & filename, i.ToString & "; " & PV2.Jahr.ToString & "; " & PV2.Monatsertrag(i).ToString & Environment.NewLine)
        Next



        If File.Exists(saveLocation.Text & "PVL_" & PV3.PVLogNummer & fileending) Then
            PV3.Monatsertrag = readFileToArray("PVL_" & PV3.PVLogNummer & fileending, 13, 0, 2)
        Else
            For i = 1 To 12
                PV3.Monatsertrag(i) = 0
            Next
        End If
        PV3.Monatsertrag(PV3.Monat) = 0
        For i = 1 To 31
            PV3.Monatsertrag(PV3.Monat) += PV3.Tagesertrag(i)
        Next

        ' Monatsfile schreiben
        filename = "PVL_" & PV3.PVLogNummer & "_" & PV3.Jahr & "_0_0_m.txt"

        File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
Solaranlage
--------------------------------------------------------------------------------------------------------
Tag; Monat; Jahr; Einspeisung in kWh

]]></a>.Value)
        For i = 1 To 12
            File.AppendAllText(saveLocation.Text & filename, i.ToString & "; " & PV3.Jahr.ToString & "; " & PV3.Monatsertrag(i).ToString & Environment.NewLine)
        Next


    End Sub

    Private Sub Tagesgrafik()
        Dim f_H As Double
        Dim f_I1 As Double
        Dim f_I2 As Double
        Dim i As Integer

        DatenfileFehlt = False
        Datenwerte_Monat_EinlesenAusFile()

        If DatenfileFehlt Then
            dayList.Items.Clear()
            dayChart.Titles.Clear()
            dayChart.Series.Clear()
            dayChart.Titles.Add(monthBox.Text & "/" & yearBox.Text)
            dayChart.Titles.Add("Datenfile fehlt")
            Return
        End If
        Dim s_H As Double = 0
        Dim s_I1 As Double = 0
        Dim s_I2 As Double = 0
        Dim p_H As Double = 0
        Dim p_I1 As Double = 0
        Dim p_I2 As Double = 0
        Dim pj_H As Double = 0
        Dim pj_I1 As Double = 0
        Dim pj_I2 As Double = 0


        dayList.Items.Clear()

        ' Set the view to show details.
        dayList.View = View.Details
        ' Allow the user to edit item text.
        dayList.LabelEdit = False
        ' Allow the user to rearrange columns.
        dayList.AllowColumnReorder = True
        ' Display check boxes.
        dayList.FullRowSelect = True
        ' Display grid lines.
        dayList.GridLines = True
        ' Sort the items in the list in ascending order.
        dayList.Sorting = SortOrder.None

        Dim ItemArray(32) As ListViewItem 'erstellt ein ListViewItem-Array

        dayList.BeginUpdate()

        ' Create columns for the items and subitems.
        ' Width of -2 indicates auto-size.
        ' ListView1.Columns.Clear()
        dayList.Columns(0).Text = "Tag"
        dayList.Columns(1).Text = TB_L1Kurzbezeichnung.Text
        dayList.Columns(2).Text = TB_L2Kurzbezeichnung.Text
        dayList.Columns(3).Text = TB_L3Kurzbezeichnung.Text
        dayList.Columns(4).Text = "n" & TB_L1Kurzbezeichnung.Text
        dayList.Columns(5).Text = "n" & TB_L2Kurzbezeichnung.Text
        dayList.Columns(6).Text = "n" & TB_L3Kurzbezeichnung.Text
        dayList.Columns(7).Text = "% " & TB_L1Kurzbezeichnung.Text
         dayList.Columns(0).Width = 45
        dayList.Columns(1).Width = 40
        dayList.Columns(2).Width = 40
        dayList.Columns(3).Width = 40
        dayList.Columns(4).Width = 40
        dayList.Columns(5).Width = 40
        dayList.Columns(6).Width = 40
        dayList.Columns(7).Width = 40
        dayList.Columns(0).TextAlign = HorizontalAlignment.Right
        dayList.Columns(1).TextAlign = HorizontalAlignment.Right
        dayList.Columns(2).TextAlign = HorizontalAlignment.Right
        dayList.Columns(3).TextAlign = HorizontalAlignment.Right
        dayList.Columns(4).TextAlign = HorizontalAlignment.Right
        dayList.Columns(5).TextAlign = HorizontalAlignment.Right
        dayList.Columns(6).TextAlign = HorizontalAlignment.Right
        dayList.Columns(7).TextAlign = HorizontalAlignment.Right
     

        Dim s As String
        For j = 0 To 31
            i = j + 1
            If i < 10 Then
                s = "  " + i.ToString
            Else
                s = i.ToString
            End If
            f_H = PV1.Tagesertrag(i) / PV1.Anlagenleistung
            f_I1 = PV2.Tagesertrag(i) / PV2.Anlagenleistung
            f_I2 = PV3.Tagesertrag(i) / PV3.Anlagenleistung
            s_H = s_H + PV1.Tagesertrag(i)
            s_I1 = s_I1 + PV2.Tagesertrag(i)
            s_I2 = s_I2 + PV3.Tagesertrag(i)

            If PV1.Tagesertrag(i) > 0.05 Then
                pj_H = pj_H + 1
            End If
            If PV2.Tagesertrag(i) > 0.05 Then
                pj_I1 = pj_I1 + 1
            End If
            If PV3.Tagesertrag(i) > 0.05 Then
                pj_I2 = pj_I2 + 1
            End If

            p_H = (f_H / (PV1.Jahressollertrag * verteil(CInt(monthBox.Text) - 1) / 100 / DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text))) * 100)
            p_I1 = (f_I1 / (PV2.Jahressollertrag * verteil(CInt(monthBox.Text) - 1) / 100 / DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text))) * 100)
            p_I2 = (f_I2 / (PV3.Jahressollertrag * verteil(CInt(monthBox.Text) - 1) / 100 / DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text))) * 100)

            Dim lvi As New ListViewItem(New String() {s, Stri_wag(PV1.Tagesertrag(i)), Stri_wag(PV2.Tagesertrag(i)), Stri_wag(PV3.Tagesertrag(i)), Stri_wag(f_H), Stri_wag(f_I1), Stri_wag(f_I2), p_H.ToString("###")})
            ItemArray(j) = lvi
        Next

        f_H = s_H / PV1.Anlagenleistung
        f_I1 = s_I1 / PV2.Anlagenleistung
        f_I2 = s_I2 / PV3.Anlagenleistung

        p_H = (f_H / (PV1.Jahressollertrag * verteil(CInt(monthBox.Text) - 1) / 100) * 100)
        p_I1 = (f_I1 / (PV2.Jahressollertrag * verteil(CInt(monthBox.Text) - 1) / 100) * 100)
        p_I2 = (f_I2 / (PV3.Jahressollertrag * verteil(CInt(monthBox.Text) - 1) / 100) * 100)

        Dim lvi2 As New ListViewItem(New String() {"Summe", Format(s_H, "####"), Format(s_I1, "####"), Format(s_I2, "####"), Stri_wag(f_H), Stri_wag(f_I1), Stri_wag(f_I2), p_H.ToString("###")})
        ItemArray(31) = lvi2

        ms1 = s_H

        p_H = (DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text)) - pj_H) / DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text)) * 100 + p_H
        p_I1 = (DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text)) - pj_I1) / DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text)) * 100 + p_I1
        p_I2 = (DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text)) - pj_I2) / DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text)) * 100 + p_I2

        Dim p_H_soll As Double
        p_H_soll = PV1.Anlagenleistung * PV1.Jahressollertrag * verteil(CInt(monthBox.Text) - 1) / 100
        Dim lvi3 As New ListViewItem(New String() {"Monat", p_H_soll.ToString("###"), "", "", "", "", "", p_H.ToString("###")})
        ItemArray(32) = lvi3

        dayList.Items.AddRange(ItemArray)


        'Geänderte Monatswerte Markieren

        For i = 1 To 32
            dayList.Items.Item(i).UseItemStyleForSubItems = False
        Next
        dayList.Items.Item(31).UseItemStyleForSubItems = True
        dayList.Items.Item(31).BackColor = Color.Gray 'Silver


        For i = 1 To kwAZ
            If Val(yearBox.Text) = kw(i).j And Val(monthBox.Text) = kw(i).m Then
                If kw(i).t <> 0 Then
                    Select Case kw(i).a
                        Case "PV1"
                            dayList.Items.Item(kw(i).t - 1).SubItems(1).BackColor = Color.Gainsboro ' WhiteSmoke
                        Case "PV2"
                            dayList.Items.Item(kw(i).t - 1).SubItems(2).BackColor = Color.Gainsboro
                        Case "PV3"
                            dayList.Items.Item(kw(i).t - 1).SubItems(3).BackColor = Color.Gainsboro
                    End Select
                End If
            End If
        Next

        dayList.EndUpdate()


        NotifyWerte(0) = s_H
        NotifyWerte(1) = s_I1
        NotifyWerte(2) = s_I2
        NotifyWerte(3) = PV1.Tagesertrag(Today.Day - 1)
        NotifyWerte(4) = PV2.Tagesertrag(Today.Day - 1)
        NotifyWerte(5) = PV3.Tagesertrag(Today.Day - 1)


        dayChart.Series.Clear()
        dayChart.Series.Add(TB_L1Name.Text)
        dayChart.Series.Add(TB_L2Name.Text)
        dayChart.Series.Add(TB_L3Name.Text)
        dayChart.ChartAreas(0).AxisX.Title = "Tage im Monat"
        dayChart.ChartAreas(0).AxisY.Title = "spezifischer Ertrag in kWh/(kWp*d)"
        dayChart.Series(TB_L1Name.Text).Color = Color.Orange
        dayChart.Series(TB_L2Name.Text).Color = Color.Blue
        dayChart.Series(TB_L3Name.Text).Color = Color.LimeGreen


        For i = 1 To 31
            dayChart.Series(TB_L1Name.Text).Points.AddY(PV1.Tagesertrag(i) / PV1.Anlagenleistung)
            dayChart.Series(TB_L2Name.Text).Points.AddY(PV2.Tagesertrag(i) / PV2.Anlagenleistung)
            dayChart.Series(TB_L3Name.Text).Points.AddY(PV3.Tagesertrag(i) / PV3.Anlagenleistung)
        Next

        dayChart.ChartAreas(0).AxisY.Maximum = Double.NaN
        dayChart.ChartAreas(0).AxisY.Minimum = Double.NaN
        dayChart.Titles.Clear()
        dayChart.Titles.Add(monthBox.Text & "/" & yearBox.Text)
        dayChart.Titles(0).Font = New Drawing.Font("Arial", 16)
        dayChart.Series(TB_L1Name.Text).IsValueShownAsLabel = True

        dayChart.Series(TB_L1Name.Text).LabelFormat = "#0.0"
        dayChart.Series(TB_L2Name.Text).LabelFormat = "#0.0"
        dayChart.Series(TB_L3Name.Text).LabelFormat = "#0.0"
        dayChart.ResetAutoValues()
        dayChart.Invalidate()
    End Sub


  
    Private Sub Datenwerte_Monat_EinlesenAusFile()
        'Dim stackFrame As New Diagnostics.StackFrame(1)
        'MsgBox(stackFrame.GetMethod.Name)
        Dim Ltemp As Solaranlage
        If (yearBox.Text.ToString = "") Then Return
        Dim fileending = "_" & yearBox.Text.ToString & "_" & monthBox.Text.ToString & "_0_t.txt"

        DatenfileFehlt = True
        ReDim Ltemp.Tagesertrag(31)

        For i = 1 To 31
            Ltemp.Tagesertrag(i) = 0
            PV1.Tagesertrag(i) = 0
        Next
        Ltemp.Tagesertrag = readFileToArray("PVL_" & PV1.PVLogNummer & fileending, 32, 0, 3)
        If Ltemp.Tagesertrag(0) <> 999999 Then
            For i = 1 To 31
                PV1.Tagesertrag(i) = Ltemp.Tagesertrag(i)
            Next
            DatenfileFehlt = False
        End If

        For i = 1 To 31
            Ltemp.Tagesertrag(i) = 0
            PV2.Tagesertrag(i) = 0
        Next
        Ltemp.Tagesertrag = readFileToArray("PVL_" & PV2.PVLogNummer & fileending, 32, 0, 3)
        If Ltemp.Tagesertrag(0) <> 999999 Then
            For i = 1 To 31
                PV2.Tagesertrag(i) = Ltemp.Tagesertrag(i)
            Next
            DatenfileFehlt = False
        End If

        For i = 1 To 31
            Ltemp.Tagesertrag(i) = 0
            PV3.Tagesertrag(i) = 0
        Next
        Ltemp.Tagesertrag = readFileToArray("PVL_" & PV3.PVLogNummer & fileending, 32, 0, 3)
        If Ltemp.Tagesertrag(0) <> 999999 Then
            For i = 1 To 31
                PV3.Tagesertrag(i) = Ltemp.Tagesertrag(i)
            Next
            DatenfileFehlt = False
        End If


        ReDim Ltemp.Tagesertrag(31)
        For i = 1 To 31
            Ltemp.Tagesertrag(i) = 0
        Next

        If CB_L1FreeSolEinlesen.Checked And File.Exists(saveLocation.Text & "FS_" & PV1.PVLogNummer & fileending) Then
            DatenfileFehlt = False
            Ltemp.Tagesertrag = readFileToArray("FS_" & PV1.PVLogNummer & fileending, 32, 0, 3)
            For i = 1 To 31
                PV1.Tagesertrag(i) = Math.Max(PV1.Tagesertrag(i), Ltemp.Tagesertrag(i))
            Next
        End If

        For i = 1 To 31
            Ltemp.Tagesertrag(i) = 0
        Next
        If CB_L2FreeSolEinlesen.Checked And File.Exists(saveLocation.Text & "FS_" & PV2.PVLogNummer & fileending) Then
            DatenfileFehlt = False
            Ltemp.Tagesertrag = readFileToArray("FS_" & PV2.PVLogNummer & fileending, 32, 0, 3)
            For i = 1 To 31
                PV2.Tagesertrag(i) = Math.Max(PV2.Tagesertrag(i), Ltemp.Tagesertrag(i))
            Next
        End If

        For i = 1 To 31
            Ltemp.Tagesertrag(i) = 0
        Next
        If CB_L3FreeSolEinlesen.Checked And File.Exists(saveLocation.Text & "FS_" & PV3.PVLogNummer & fileending) Then
            DatenfileFehlt = False
            Ltemp.Tagesertrag = readFileToArray("FS_" & PV3.PVLogNummer & fileending, 32, 0, 3)
            For i = 1 To 31
                PV3.Tagesertrag(i) = Math.Max(PV3.Tagesertrag(i), Ltemp.Tagesertrag(i))
            Next
        End If
        Datenkorrektur()
    End Sub

    Private Sub Monatsgrafik()

        Dim f_H As Double
        Dim f_I1 As Double
        Dim f_I2 As Double

        DatenfileFehlt = False
        Datenwerte_Jahr_EinlesenAusFile()

        If DatenfileFehlt Then
            monthChart.Titles.Clear()
            monthChart.Series.Clear()
            monthChart.Titles.Add(monthBox.Text & "/" & yearBox.Text)
            monthChart.Titles.Add("Datenfile fehlt")
            Return
        End If

        monthList.Items.Clear()
        Dim ItemArray(15) As ListViewItem 'erstellt ein ListViewItem-Array
        Dim i As Integer

        Dim s_H As Double = 0
        Dim s_I1 As Double = 0
        Dim s_I2 As Double = 0
        Dim p_H As Double = 0
        Dim p_I1 As Double = 0
        Dim p_I2 As Double = 0
        Dim pj_h As Double = 0
        Dim pj_i1 As Double = 0
        Dim pj_i2 As Double = 0

        Dim s As String

        ' Set the view to show details.
        monthList.View = View.Details
        ' Allow the user to edit item text.
        monthList.LabelEdit = False
        ' Allow the user to rearrange columns.
        monthList.AllowColumnReorder = True
        ' Display check boxes.
        monthList.FullRowSelect = True
        ' Display grid lines.
        monthList.GridLines = True
        ' Sort the items in the list in ascending order.
        monthList.Sorting = SortOrder.None


        monthList.BeginUpdate()

        ' Create columns for the items and subitems.
        ' Width of -2 indicates auto-size.
        ' ListView1.Columns.Clear()
        monthList.Columns(0).Text = "Monat"
        monthList.Columns(1).Text = TB_L1Kurzbezeichnung.Text
        monthList.Columns(2).Text = TB_L2Kurzbezeichnung.Text
        monthList.Columns(3).Text = TB_L3Kurzbezeichnung.Text
        monthList.Columns(4).Text = "n" & TB_L1Kurzbezeichnung.Text
        monthList.Columns(5).Text = "n" & TB_L2Kurzbezeichnung.Text
        monthList.Columns(6).Text = "n" & TB_L3Kurzbezeichnung.Text
        monthList.Columns(7).Text = "% " & TB_L1Kurzbezeichnung.Text
        monthList.Columns(0).Width = 50
        monthList.Columns(1).Width = 45
        monthList.Columns(2).Width = 45
        monthList.Columns(3).Width = 45
        monthList.Columns(4).Width = 45
        monthList.Columns(5).Width = 45
        monthList.Columns(6).Width = 45
        monthList.Columns(7).Width = 45
        monthList.Columns(0).TextAlign = HorizontalAlignment.Right
        monthList.Columns(1).TextAlign = HorizontalAlignment.Right
        monthList.Columns(2).TextAlign = HorizontalAlignment.Right
        monthList.Columns(3).TextAlign = HorizontalAlignment.Right
        monthList.Columns(4).TextAlign = HorizontalAlignment.Right
        monthList.Columns(5).TextAlign = HorizontalAlignment.Right
        monthList.Columns(6).TextAlign = HorizontalAlignment.Right
        monthList.Columns(7).TextAlign = HorizontalAlignment.Right
      



        For j = 0 To 11
            i = j + 1
            f_H = PV1.Monatsertrag(i) / PV1.Anlagenleistung
            f_I1 = PV2.Monatsertrag(i) / PV2.Anlagenleistung
            f_I2 = PV3.Monatsertrag(i) / PV3.Anlagenleistung
            s_H = s_H + PV1.Monatsertrag(i)
            s_I1 = s_I1 + PV2.Monatsertrag(i)
            s_I2 = s_I2 + PV3.Monatsertrag(i)

            If i < 10 Then
                s = "  " + i.ToString
            Else
                s = i.ToString
            End If
            If PV1.Monatsertrag(i) < 0.05 Then
                pj_h = pj_h + verteil(j)
            End If
            If PV2.Monatsertrag(i) < 0.05 Then
                pj_i1 = pj_i1 + verteil(j)
            End If
            If PV3.Monatsertrag(i) < 0.05 Then
                pj_i2 = pj_i2 + verteil(j)
            End If

            p_H = (f_H / (PV1.Jahressollertrag * verteil(j) / 100) * 100)
            p_I1 = (f_I1 / (PV2.Jahressollertrag * verteil(j) / 100) * 100)
            p_I2 = (f_I2 / (PV3.Jahressollertrag * verteil(j) / 100) * 100)

            Dim lvi As New ListViewItem(New String() {s, Format(PV1.Monatsertrag(i), "####"), Format(PV2.Monatsertrag(i), "####"), Format(PV3.Monatsertrag(i), "####"), Stri_wag(f_H), Stri_wag(f_I1), Stri_wag(f_I2), p_H.ToString("###")})
            ItemArray(j) = lvi
        Next
        f_H = s_H / PV1.Anlagenleistung
        f_I1 = s_I1 / PV2.Anlagenleistung
        f_I2 = s_I2 / PV3.Anlagenleistung

        p_H = (f_H / (PV1.Jahressollertrag) * 100)
        p_I1 = (f_I1 / (PV2.Jahressollertrag) * 100)
        p_I2 = (f_I2 / (PV3.Jahressollertrag) * 100)

        Dim lvi2 As New ListViewItem(New String() {"Summe", Format(s_H, "####"), Format(s_I1, "####"), Format(s_I2, "####"), Stri_wag(f_H), Stri_wag(f_I1), Stri_wag(f_I2), p_H.ToString("###")})
        ItemArray(12) = lvi2

        p_H = (f_H / PV1.Jahressollertrag * 100) + pj_h + verteil(CInt(monthBox.Text) - 1) * (DateTime.DaysInMonth(PV1.aktualisierungsstand.Year, PV1.aktualisierungsstand.Month) - PV1.aktualisierungsstand.Day) / DateTime.DaysInMonth(PV1.aktualisierungsstand.Year, PV1.aktualisierungsstand.Month)
        p_I1 = (f_I1 / PV1.Jahressollertrag * 100) + pj_i1 + verteil(CInt(monthBox.Text) - 1) * (DateTime.DaysInMonth(PV2.aktualisierungsstand.Year, PV2.aktualisierungsstand.Month) - PV2.aktualisierungsstand.Day) / DateTime.DaysInMonth(PV2.aktualisierungsstand.Year, PV2.aktualisierungsstand.Month)
        p_I2 = (f_I2 / PV1.Jahressollertrag * 100) + pj_i2 + verteil(CInt(monthBox.Text) - 1) * (DateTime.DaysInMonth(PV3.aktualisierungsstand.Year, PV3.aktualisierungsstand.Month) - PV3.aktualisierungsstand.Day) / DateTime.DaysInMonth(PV3.aktualisierungsstand.Year, PV3.aktualisierungsstand.Month)

        Dim lvi3 As New ListViewItem(New String() {"Jahr", "%", "", "", "", "", "", p_H.ToString("###")})
        ItemArray(13) = lvi3

        p_H = p_H * PV1.Jahressollertrag / 100
        p_I1 = p_I1 * PV2.Jahressollertrag / 100
        p_I2 = p_I2 * PV3.Jahressollertrag / 100


        Dim lvi4 As New ListViewItem(New String() {"Jahr", "kWh", yearBox.Text, "", "", "", "", p_H.ToString("###")})
        ItemArray(14) = lvi4

        Dim PV1_anzeig As String = "unbek."
        Dim PV2_anzeig As String = "unbek."
        Dim PV3_anzeig As String = "unbek."

        If Val(yearBox.Text) >= 2010 Then
            yearBox.Text = (Val(yearBox.Text) - 1).ToString
            Datenwerte_Jahr_EinlesenAusFile()
            For i = 1 To 12
                PV1.MonatsertragVorjahr(i) = PV1.Monatsertrag(i)
                PV2.MonatsertragVorjahr(i) = PV2.Monatsertrag(i)
                PV3.MonatsertragVorjahr(i) = PV3.Monatsertrag(i)
            Next

            yearBox.Text = (Val(yearBox.Text) + 1).ToString
            Datenwerte_Jahr_EinlesenAusFile()

            Dim PV1_Korrekt As Boolean = True
            Dim PV2_Korrekt As Boolean = True
            Dim PV3_Korrekt As Boolean = True

            Dim PV1_Sum As Double = 0
            Dim PV2_Sum As Double = 0
            Dim PV3_Sum As Double = 0

            ' Monatswerte im Laufenden Jahr
            For i = 1 To CInt(monthBox.Text) - 1
                PV1_Sum = PV1_Sum + PV1.Monatsertrag(i)
                PV2_Sum = PV2_Sum + PV2.Monatsertrag(i)
                PV3_Sum = PV3_Sum + PV3.Monatsertrag(i)
                If PV1.Monatsertrag(i) < 0.05 Then
                    PV1_Korrekt = False
                End If
                If PV3.Monatsertrag(i) < 0.05 Then
                    PV2_Korrekt = False
                End If
                If PV3.Monatsertrag(i) < 0.05 Then
                    PV3_Korrekt = False
                End If
            Next

            ' Monatswerte im Vorjahr
            For i = CInt(monthBox.Text) To 12
                PV1_Sum = PV1_Sum + PV1.MonatsertragVorjahr(i)
                PV2_Sum = PV2_Sum + PV2.MonatsertragVorjahr(i)
                PV3_Sum = PV3_Sum + PV3.MonatsertragVorjahr(i)
                If PV1.MonatsertragVorjahr(i) < 0.05 Then
                    PV1_Korrekt = False
                End If
                If PV2.MonatsertragVorjahr(i) < 0.05 Then
                    PV2_Korrekt = False
                End If
                If PV3.MonatsertragVorjahr(i) < 0.05 Then
                    PV3_Korrekt = False
                End If
            Next

            If PV1_Korrekt Then
                PV1_anzeig = (PV1_Sum / PV1.Anlagenleistung).ToString("####0")
            End If
            If PV2_Korrekt Then
                PV2_anzeig = (PV2_Sum / PV2.Anlagenleistung).ToString("####0")
            End If
            If PV3_Korrekt Then
                PV3_anzeig = (PV3_Sum / PV3.Anlagenleistung).ToString("####0")
            End If
        End If


        Dim lvi5 As New ListViewItem(New String() {"Jahr", "kWh", "roll.", (Val(monthBox.Text)).ToString, (Val(yearBox.Text) - 1).ToString, (Val(monthBox.Text) - 1).ToString, (Val(yearBox.Text)).ToString, PV1_anzeig})

        ItemArray(15) = lvi5

        'Geänderte Monatswerte Markieren

        monthList.Items.AddRange(ItemArray)
        For i = 1 To 15
            monthList.Items.Item(i).UseItemStyleForSubItems = False
        Next
        monthList.Items.Item(12).UseItemStyleForSubItems = True
        monthList.Items.Item(12).BackColor = Color.Gray 'Silver


        For i = 1 To kwAZ
            If Val(yearBox.Text) = kw(i).j Then
                If kw(i).t = 0 Then
                    Select Case kw(i).a
                        Case "PV1"
                            monthList.Items.Item(kw(i).m - 1).SubItems(1).BackColor = Color.Gainsboro ' WhiteSmoke
                        Case "PV2"
                            monthList.Items.Item(kw(i).m - 1).SubItems(2).BackColor = Color.Gainsboro
                        Case "PV3"
                            monthList.Items.Item(kw(i).m - 1).SubItems(3).BackColor = Color.Gainsboro
                    End Select
                End If
            End If
        Next

        ' Inkonsistente Monatswerte markieren
        For i = 1 To 12
            For j = 1 To 3
                If Datenkonsistenz(j, i) = 0 Then
                    monthList.Items.Item(i - 1).SubItems(j).ForeColor = Color.Red
                ElseIf Datenkonsistenz(j, i) = 2 Then
                    monthList.Items.Item(i - 1).SubItems(j).ForeColor = Color.LimeGreen
                End If
            Next
        Next
        monthList.EndUpdate()

        ' Grafik zeichnen

        monthChart.Series.Clear() 'RemoveAt(0)
        monthChart.Series.Add(TB_L1Name.Text)
        monthChart.Series.Add(TB_L2Name.Text)
        monthChart.Series.Add(TB_L3Name.Text)
        monthChart.Series(TB_L1Name.Text).Color = Color.Orange
        monthChart.Series(TB_L2Name.Text).Color = Color.Blue
        monthChart.Series(TB_L3Name.Text).Color = Color.LimeGreen
        monthChart.ChartAreas(0).AxisX.Title = "Monate im Jahr"
        monthChart.ChartAreas(0).AxisY.Title = "spezifischer Ertrag in kWh/(kWp*d)"

        For i = 1 To 12
            monthChart.Series(TB_L1Name.Text).Points.AddY(PV1.Monatsertrag(i) / PV1.Anlagenleistung)
            monthChart.Series(TB_L2Name.Text).Points.AddY(PV2.Monatsertrag(i) / PV2.Anlagenleistung)
            monthChart.Series(TB_L3Name.Text).Points.AddY(PV3.Monatsertrag(i) / PV3.Anlagenleistung)
        Next

        monthChart.ChartAreas(0).AxisY.Maximum = Double.NaN
        monthChart.ChartAreas(0).AxisY.Minimum = Double.NaN
        monthChart.Titles.Clear()
        monthChart.Titles.Add(yearBox.Text)
        monthChart.Titles(0).Font = New Drawing.Font("Arial", 16)
        monthChart.Series(TB_L1Name.Text).IsValueShownAsLabel = True
        monthChart.Series(TB_L1Name.Text).LabelFormat = "###0.0"

        monthChart.ResetAutoValues()
        monthChart.Invalidate()
    End Sub

 
    Private Function Stri_wag(ByVal f As Double) As String
        If f < 0.05 Then
            Stri_wag = " "
        Else
            Stri_wag = Format(f, "##0.00")

        End If
    End Function

    Private Sub Datenwerte_Jahr_EinlesenAusFile()
        If (yearBox.Text.ToString = "") Then Return
        Dim fileending = "_" & yearBox.Text.ToString & "_0_0_m.txt"
        Try
            PV1.Monatsertrag = readFileToArray("PVL_" & PV1.PVLogNummer & fileending, 13, 0, 2)
            PV2.Monatsertrag = readFileToArray("PVL_" & PV2.PVLogNummer & fileending, 13, 0, 2)
            PV3.Monatsertrag = readFileToArray("PVL_" & PV3.PVLogNummer & fileending, 13, 0, 2)
            Datenkorrektur()
            DatenkonsistenzPrüfen()
        Catch ex As FileNotFoundException
            DatenfileFehlt = True
        End Try
    End Sub

    Private Sub DatenkonsistenzPrüfen()
        Dim tb4temp As String = monthBox.Text
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim sum_h As Double
        Dim sum_i1 As Double
        Dim sum_i2 As Double


        For i = 1 To 3
            For j = 1 To 12
                Datenkonsistenz(i, j) = 1
            Next
        Next


        For i = 1 To 12
            sum_h = 0
            sum_i1 = 0
            sum_i2 = 0
            DatenfileFehlt = False
            monthBox.Text = i.ToString
            Datenwerte_Monat_EinlesenAusFile()
            If Not DatenfileFehlt Then
                For k = 1 To 31
                    sum_h = sum_h + PV1.Tagesertrag(k)
                    sum_i1 = sum_i1 + PV2.Tagesertrag(k)
                    sum_i2 = sum_i2 + PV3.Tagesertrag(k)
                Next
            End If
            If (sum_h - PV1.Monatsertrag(i)) > 0.5 Then
                Datenkonsistenz(1, i) = 0
            ElseIf (sum_h - PV1.Monatsertrag(i)) < -0.5 Then
                Datenkonsistenz(1, i) = 2
            End If
            If (sum_i1 - PV2.Monatsertrag(i)) > 0.5 Then
                Datenkonsistenz(2, i) = 0
            ElseIf (sum_i1 - PV2.Monatsertrag(i)) < -0.5 Then
                Datenkonsistenz(2, i) = 2
            End If
            If (sum_i2 - PV3.Monatsertrag(i)) > 0.5 Then
                Datenkonsistenz(3, i) = 0
            ElseIf (sum_i2 - PV3.Monatsertrag(i)) < -0.5 Then
                Datenkonsistenz(3, i) = 2
            End If
        Next
        monthBox.Text = tb4temp
        Datenwerte_Monat_EinlesenAusFile()
        DatenfileFehlt = False
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim t1 As DateTime = DateTime.Parse(dayBox.Text & "-" & monthBox.Text & "-" & yearBox.Text)

        t1 = t1.AddMonths(-1)

        dayBox.Text = t1.Day.ToString
        monthBox.Text = t1.Month.ToString
        yearBox.Text = t1.Year.ToString

        Grafikaktualisierung()
        statusBox.Text = ""

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim t1 As DateTime = DateTime.Parse(dayBox.Text & "-" & monthBox.Text & "-" & yearBox.Text)

        t1 = t1.AddMonths(+1)

        dayBox.Text = t1.Day.ToString
        monthBox.Text = t1.Month.ToString
        yearBox.Text = t1.Year.ToString

        Grafikaktualisierung()
        statusBox.Text = ""
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim t1 As DateTime = DateTime.Parse(dayBox.Text & "-" & monthBox.Text & "-" & yearBox.Text)

        t1 = t1.AddYears(-1)

        dayBox.Text = t1.Day.ToString
        monthBox.Text = t1.Month.ToString
        yearBox.Text = t1.Year.ToString

        Grafikaktualisierung()
        statusBox.Text = ""
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        Dim t1 As DateTime = DateTime.Parse(dayBox.Text & "-" & monthBox.Text & "-" & yearBox.Text)

        t1 = t1.AddYears(+1)

        dayBox.Text = t1.Day.ToString
        monthBox.Text = t1.Month.ToString
        yearBox.Text = t1.Year.ToString

        Grafikaktualisierung()
        statusBox.Text = ""
    End Sub



    Private Sub AktualisierungPrüfen()
        If Today.AddDays(-1).Month = Val(monthBox.Text) Then
            For i = 31 To 1 Step -1
                If PV1.Tagesertrag(i) > 0.05 Then
                    PV1.aktualisierungsstand = Today.AddDays(-Today.AddDays(-1).Day + i - 1)
                    i = 1
                    Label2.Text = PV1.Aktualisierungsstand.ToString("dd.MM.yyyy")
                    If Today.AddDays(-1).Day = PV1.aktualisierungsstand.Day Then
                        Label8.Text = "aktuell"
                        Label8.BackColor = Color.Lime
                    Else
                        Label8.Text = "nicht aktuell"
                        Label8.BackColor = Color.Red
                    End If
                End If
            Next
            For i = 31 To 1 Step -1
                If PV2.Tagesertrag(i) > 0.05 Then
                    PV2.aktualisierungsstand = Today.AddDays(-Today.AddDays(-1).Day + i - 1)
                    i = 1
                    Label7.Text = PV2.aktualisierungsstand.ToString("dd.MM.yyyy")
                    If Today.AddDays(-1).Day = PV2.aktualisierungsstand.Day Then
                        Label10.Text = "aktuell"
                        Label10.BackColor = Color.Lime
                    Else
                        Label10.Text = "nicht aktuell"
                        Label10.BackColor = Color.Red
                    End If
                End If
            Next
            For i = 31 To 1 Step -1
                If PV3.Tagesertrag(i) > 0.05 Then
                    PV3.aktualisierungsstand = Today.AddDays(-Today.AddDays(-1).Day + i - 1)
                    i = 1
                    Label6.Text = PV3.aktualisierungsstand.ToString("dd.MM.yyyy")
                    If Today.AddDays(-1).Day = PV3.aktualisierungsstand.Day Then
                        Label9.Text = "aktuell"
                        Label9.BackColor = Color.Lime
                    Else
                        Label9.Text = "nicht aktuell"
                        Label9.BackColor = Color.Red
                    End If
                End If
            Next
            If Today.AddDays(-1).Day = PV1.aktualisierungsstand.Day And Today.AddDays(-1).Day = PV2.aktualisierungsstand.Day And Today.AddDays(-1).Day = PV3.aktualisierungsstand.Day Then
                Label1.Text = "Daten aktuell"
                Label1.BackColor = Color.Lime
            ElseIf Today.AddDays(-1).Day = PV1.Aktualisierungsstand.Day Or Today.AddDays(-1).Day = PV2.Aktualisierungsstand.Day Or Today.AddDays(-1).Day = PV3.Aktualisierungsstand.Day Then
                Label1.Text = "Daten teils aktuell"
                Label1.BackColor = Color.Yellow
            Else
                Label1.Text = "Daten nicht aktuell"
                Label1.BackColor = Color.Red
            End If
        End If

    End Sub

    Private Sub Grafikaktualisierung()
        Tagesgrafik()
        Monatsgrafik()
        MinutenwerteAnzeigen()
        AktualisierungPrüfen()
        My.Settings.Reload()
    End Sub


    Private Sub Hilfe_Button(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        MessageBox.Show("Das Tool visualisiert Solarertragsdaten und Eigenverbaruchsdaten einer Solaranlage." & vbNewLine & vbNewLine _
                       & " Das Tool ist getestet mit der Anordnung Solarwerte (erste Spalte), Bezugswerte (2. Spalte), Einspeisung (3. Spalte)" & vbNewLine & vbNewLine _
                      & "'Aktualisieren' lädt Daten des aktuell eingestellten Monats neu." & vbNewLine & vbNewLine _
                      & "'Tagesgrafik' zeigt absolute und spezifische Erträge für aktuellen Monat. Die Werte in der Zeile 'Monat' sind dabei Hochrechnungen in % auf den Gesamtmonat, wenn ab dem morgigen Tag Sollwerte erzielt werden." & vbNewLine & vbNewLine _
                      & "'Monatsgrafik' funktioniert analog. Rot markierte Monatswerte zeigen Abweichungen zu dem aus der Summe der Tageswerte berechneten Monatswert. Grau hinterlegte Zellen zeigen manuell korrigierte Werte (dort sind auch oft zusätzlich Abweichungen zu finden). Die Werte in der Zeile 'Jahr' bei 'Monatsgrafik' sind Hochrechnungen in % auf das Gesamtjahr, wenn ab dem morgigen Tag Sollwerte erzielt werden. In der Zeile mit ""roll."" werden rollierend die Jahressummen vom Vormonat des eingestellten Monats bis 12 Monate zurück angegeben." & vbNewLine & vbNewLine _
                      & " Alle Werte in kWh pro Tag oder Monat " & vbNewLine & vbNewLine _
                      & " Vorsilbe 'n': spezifische (normierte) Ertragswerte in kWh/kWp" & vbNewLine & vbNewLine _
                      & " Vorsilbe '%': Ertragswerte in Prozent des erwarteten Tageswerts (aus Monatsverteilung, alle Tage im Monat haben gleichen Erwartungswert, Anlage hat 950 kWh/kWp)" & vbNewLine & vbNewLine _
                      & " Minutenwerte: Erlaubt Detailanzeige eines Einzeltages. Beim ersten Laden Aktualisieren drücken, Anzeige dauert etwas." & vbNewLine & vbNewLine _
                      & "Daten aktuell: Wenn die Daten vom Vortag geladen sind, wird der Stand als aktuell betrachtet. Dies sollte bis ca. 9 Uhr Folgetag möglich sein. Trotzdem können natürlich einzelne alte Monate fehlen, dies wird dann in der Monatsansicht angezeigt." & vbNewLine & vbNewLine _
                      & "Der Gebrauch des Korrekturwerte.txt Files, das im Verzeichnis des *.exe liegen muss, ist im File selbst beschrieben. Hellgrau hinterlegte Tabellenwerte markieren jeweils Einträge, die durch das Korrekturfile überschrieben wurden. Falls im Laufenden Monat Tageskorrekturen vorgenommen wurden, aber keine Monatskorrektur, wird der Monatswert auf die Summe der korrigierten Tageswerte angepasst, ohne als grau hinterlegt gekennzeichnet zu sein. Am Monatsende muss der Monatswert dann manuell korrigiert werden." & vbNewLine & vbNewLine _
                      & "Während eines Datendownloads sollte man kein Datum ändern, könnte zum Abspeichern in falschen Files führen")
    End Sub




    Private Sub ContextExit(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Application.Exit()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ReDim PV1.Tagesertrag(32)
        ReDim PV2.Tagesertrag(32)
        ReDim PV3.Tagesertrag(32)
        ReDim PV1.Monatsertrag(13)
        ReDim PV2.Monatsertrag(13)
        ReDim PV3.Monatsertrag(13)
        ReDim PV1.MonatsertragVorjahr(13)
        ReDim PV2.MonatsertragVorjahr(13)
        ReDim PV3.MonatsertragVorjahr(13)
        ReDim PV1.Minutenertrag(288)
        ReDim PV2.Minutenertrag(288)
        ReDim PV3.Minutenertrag(288)

        Anlage = 1
        RadioButton4.Checked = True
        My.Settings.Reload()
        saveLocation.Text = My.Settings.Speicherort
        TB_L2PVLogNummer.Text = My.Settings.LogStandHome
        TB_L3PVLogNummer.Text = My.Settings.LogStandBezug
        CheckBox2.Checked = My.Settings.MinAktNurBeiVollstDaten
        LoggerBugFix.Checked = My.Settings.LoggerBugFix ' JAU 09.01.2013
        CB_L1_Quelle.SelectedIndex = My.Settings.L1Quelle ' JAU 09.01.2013
        CB_L2_Quelle.SelectedIndex = My.Settings.L2Quelle
        CB_L3_Quelle.SelectedIndex = My.Settings.L3Quelle

        TB_L1Kurzbezeichnung.Text = My.Settings.L1Kurzbezeichnung
        TB_L2Kurzbezeichnung.Text = My.Settings.L2Kurzbezeichnung
        TB_L3Kurzbezeichnung.Text = My.Settings.L3Kurzbezeichnung

        If TB_L1Kurzbezeichnung.Text = "" Then TB_L1Kurzbezeichnung.Text = "1"
        If TB_L2Kurzbezeichnung.Text = "" Then TB_L2Kurzbezeichnung.Text = "2"
        If TB_L3Kurzbezeichnung.Text = "" Then TB_L3Kurzbezeichnung.Text = "3"

        TB_L1Name.Text = My.Settings.L1Name
        TB_L2Name.Text = My.Settings.L2Name
        TB_L3Name.Text = My.Settings.L3Name

        If TB_L1Name.Text = "" Then TB_L1Name.Text = "PV1"
        If TB_L2Name.Text = "" Then TB_L2Name.Text = "PV2"
        If TB_L3Name.Text = "" Then TB_L3Name.Text = "PV3"

        Label3.Text = My.Settings.L1Name
        Label5.Text = My.Settings.L2Name
        Label4.Text = My.Settings.L3Name


        TB_L1PVLogNummer.Text = My.Settings.L1PVLogNummer
        TB_L2PVLogNummer.Text = My.Settings.L2PVLogNummer
        TB_L3PVLogNummer.Text = My.Settings.L3PVLogNummer

        PV1.PVLogNummer = CInt(Val(TB_L1PVLogNummer.Text))
        PV2.PVLogNummer = CInt(Val(TB_L2PVLogNummer.Text))
        PV3.PVLogNummer = CInt(Val(TB_L3PVLogNummer.Text))

        TB_L1FreeSolURL.Text = My.Settings.L1FreeSolURL
        TB_L2FreeSolURL.Text = My.Settings.L2FreeSolURL
        TB_L3FreeSolURL.Text = My.Settings.L3FreeSolURL

        CB_L1LoggerAktiv.Checked = My.Settings.L1LoggerAktiv
        CB_L2LoggerAktiv.Checked = My.Settings.L2LoggerAktiv
        CB_L3LoggerAktiv.Checked = My.Settings.L3LoggerAktiv

        CB_L1PVLogEinlesen.Checked = My.Settings.L1PVLogEinlesen
    
        CB_L1FreeSolEinlesen.Checked = My.Settings.L1FreeSolEinlesen
        CB_L2FreeSolEinlesen.Checked = My.Settings.L2FreeSolEinlesen
        CB_L3FreeSolEinlesen.Checked = My.Settings.L3FreeSolEinlesen

        TB_L1Anlagenleistung.Text = My.Settings.l1Anlagenleistung
     
        PV1.Anlagenleistung = CDbl(Val(TB_L1Anlagenleistung.Text.Replace(",", "."))) '11.27
        PV2.Anlagenleistung = CDbl(Val(TB_L1Anlagenleistung.Text.Replace(",", "."))) '11.27
        PV3.Anlagenleistung = CDbl(Val(TB_L1Anlagenleistung.Text.Replace(",", "."))) '11.27

        TB_L1Jahressollertrag.Text = My.Settings.L1Jahressollertrag
      
        PV1.Jahressollertrag = CDbl(Val(TB_L1Jahressollertrag.Text))
        TextBox1.Text = My.Settings.FilePrefix

        CheckedListBox1.SetItemChecked(0, My.Settings.CBSolar)
        CheckedListBox1.SetItemChecked(1, My.Settings.CBBezug)
        CheckedListBox1.SetItemChecked(2, My.Settings.CBEinspeisung)
        CheckedListBox1.SetItemChecked(3, My.Settings.CBVerbrauch)
        CheckedListBox1.SetItemChecked(4, My.Settings.CBSolarverbrauch)
        CheckedListBox1.SetItemChecked(5, My.Settings.CBBasisverbrauch)

        If Not Directory.Exists(saveLocation.Text) Then
            MessageBox.Show("Es existiert kein Verzeichnis " & saveLocation.Text & ", bitte anlegen.")
            saveLocation.Text = "c:\temp\"
            Me.Close()
        End If
        Me.Text = "FreeSol EV 2.38"
        Me.WindowState = FormWindowState.Maximized

        monthBox.Text = Today.AddDays(0).Month.ToString
        yearBox.Text = Today.AddDays(0).Year.ToString

        DatenkorrekturwerteEinlesen()

        arguments = Environment.GetCommandLineArgs

        dayBox.Text = Today.Day.ToString

        DateTimePicker1.Value = Today.Date.AddDays(-2)
        DateTimePicker2.Value = Today.Date.AddDays(-1)
        DateTimePicker3.Value = Today.Date


        Grafikaktualisierung()
        TabControl1.SelectTab(2)
        statusBox.Text = ""

        TextBox13.Text = My.Settings.PortalURL
        CheckBox8.Checked = My.Settings.PortalAktiv


    End Sub


    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        My.Settings.Speicherort = saveLocation.Text
        My.Settings.MinAktNurBeiVollstDaten = CheckBox2.Checked
        My.Settings.LoggerBugFix = LoggerBugFix.Checked ' JAU 09.01.2012
        My.Settings.L1Quelle = CB_L1_Quelle.SelectedIndex ' JAU 09.01.2012
        My.Settings.L2Quelle = CB_L2_Quelle.SelectedIndex
        My.Settings.L3Quelle = CB_L3_Quelle.SelectedIndex

        My.Settings.L1Kurzbezeichnung = TB_L1Kurzbezeichnung.Text
        My.Settings.L2Kurzbezeichnung = TB_L2Kurzbezeichnung.Text
        My.Settings.L3Kurzbezeichnung = TB_L3Kurzbezeichnung.Text

        My.Settings.L1Name = TB_L1Name.Text
        My.Settings.L2Name = TB_L2Name.Text
        My.Settings.L3Name = TB_L3Name.Text

        My.Settings.L1PVLogNummer = TB_L1PVLogNummer.Text
        My.Settings.L2PVLogNummer = TB_L2PVLogNummer.Text
        My.Settings.L3PVLogNummer = TB_L3PVLogNummer.Text

        My.Settings.L1FreeSolURL = TB_L1FreeSolURL.Text
        My.Settings.L2FreeSolURL = TB_L2FreeSolURL.Text
        My.Settings.L3FreeSolURL = TB_L3FreeSolURL.Text

        My.Settings.L1LoggerAktiv = CB_L1LoggerAktiv.Checked
        My.Settings.L2LoggerAktiv = CB_L2LoggerAktiv.Checked
        My.Settings.L3LoggerAktiv = CB_L3LoggerAktiv.Checked

        My.Settings.L1PVLogEinlesen = CB_L1PVLogEinlesen.Checked

        My.Settings.L1FreeSolEinlesen = CB_L1FreeSolEinlesen.Checked
        My.Settings.L2FreeSolEinlesen = CB_L2FreeSolEinlesen.Checked
        My.Settings.L3FreeSolEinlesen = CB_L3FreeSolEinlesen.Checked

        My.Settings.l1Anlagenleistung = TB_L1Anlagenleistung.Text

        My.Settings.L1Jahressollertrag = TB_L1Jahressollertrag.Text
        My.Settings.FilePrefix = TextBox1.Text

        My.Settings.CBSolar = CheckedListBox1.GetItemChecked(0)
        My.Settings.CBBezug = CheckedListBox1.GetItemChecked(1)
        My.Settings.CBEinspeisung = CheckedListBox1.GetItemChecked(2)
        My.Settings.CBVerbrauch = CheckedListBox1.GetItemChecked(3)
        My.Settings.CBSolarverbrauch = CheckedListBox1.GetItemChecked(4)
        My.Settings.CBBasisverbrauch = CheckedListBox1.GetItemChecked(5)

        My.Settings.PortalURL = TextBox13.Text
        My.Settings.PortalAktiv = CheckBox8.Checked
        My.Settings.Save()
    End Sub



    Private Sub saveLocation_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles saveLocation.Leave
        If Not saveLocation.Text.EndsWith("\") Then saveLocation.AppendText("\")
    End Sub




    Private Sub Datenkorrektur()
        Dim i As Integer

        ' Bugs in freesol-Files korrigieren (Werte kleiner 0)
        For i = 1 To 287
            If PV1.Minutenertrag(i) < 0 Then
                If PV1.Minutenertrag(i - 1) >= -PV1.Minutenertrag(i) Then
                    PV1.Minutenertrag(i - 1) = PV1.Minutenertrag(i - 1) + PV1.Minutenertrag(i)
                    PV1.Minutenertrag(i) = 0
                ElseIf PV1.Minutenertrag(i + 1) >= -PV1.Minutenertrag(i) Then
                    PV1.Minutenertrag(i + 1) = PV1.Minutenertrag(i + 1) + PV1.Minutenertrag(i)
                    PV1.Minutenertrag(i) = 0
                End If
            End If
        Next
        i = 288
        If PV1.Minutenertrag(i) < 0 Then
            If PV1.Minutenertrag(i - 1) >= -PV1.Minutenertrag(i) Then
                PV1.Minutenertrag(i - 1) = PV1.Minutenertrag(i - 1) + PV1.Minutenertrag(i)
                PV1.Minutenertrag(i) = 0
            End If
        End If

        For i = 1 To 287
            If PV2.Minutenertrag(i) < 0 Then
                If PV2.Minutenertrag(i - 1) >= -PV2.Minutenertrag(i) Then
                    PV2.Minutenertrag(i - 1) = PV2.Minutenertrag(i - 1) + PV2.Minutenertrag(i)
                    PV2.Minutenertrag(i - 1) = PV2.Minutenertrag(i - 1) / 2
                    PV2.Minutenertrag(i) = PV2.Minutenertrag(i - 1)
                ElseIf PV2.Minutenertrag(i + 1) >= -PV2.Minutenertrag(i) Then
                    PV2.Minutenertrag(i + 1) = PV2.Minutenertrag(i + 1) + PV2.Minutenertrag(i)
                    PV2.Minutenertrag(i + 1) = PV2.Minutenertrag(i + 1) / 2
                    PV2.Minutenertrag(i) = PV2.Minutenertrag(i + 1)
                Else
                    PV2.Minutenertrag(i) = 0
                    PV3.Minutenertrag(i) = 0
                End If
            End If
            If LoggerBugFix.Checked Then ' JAU 09.01.2012
                If PV2.Minutenertrag(i) > 2000 Then
                    PV2.Minutenertrag(i) = 0
                    PV3.Minutenertrag(i) = 0
                End If
            End If
        Next
        i = 288
        If PV2.Minutenertrag(i) < 0 Then
            If PV2.Minutenertrag(i - 1) >= -PV2.Minutenertrag(i) Then
                PV2.Minutenertrag(i - 1) = PV2.Minutenertrag(i - 1) + PV2.Minutenertrag(i)
                PV2.Minutenertrag(i - 1) = PV2.Minutenertrag(i - 1) / 2
                PV2.Minutenertrag(i) = PV2.Minutenertrag(i - 1)
            Else
                PV2.Minutenertrag(i) = 0
                PV3.Minutenertrag(i) = 0
            End If
        End If
        If LoggerBugFix.Checked Then ' JAU 09.01.2012
            If PV2.Minutenertrag(i) > 2000 Then
                PV2.Minutenertrag(i) = 0
                PV3.Minutenertrag(i) = 0
            End If
        End If

        For i = 1 To 287
            If PV3.Minutenertrag(i) < 0 Then
                If PV3.Minutenertrag(i - 1) >= -PV3.Minutenertrag(i) Then
                    PV3.Minutenertrag(i - 1) = PV3.Minutenertrag(i - 1) + PV3.Minutenertrag(i)
                    PV3.Minutenertrag(i - 1) = PV3.Minutenertrag(i - 1) / 2
                    PV3.Minutenertrag(i) = PV3.Minutenertrag(i - 1)
                ElseIf PV3.Minutenertrag(i + 1) >= -PV3.Minutenertrag(i) Then
                    PV3.Minutenertrag(i + 1) = PV3.Minutenertrag(i + 1) + PV3.Minutenertrag(i)
                    PV3.Minutenertrag(i + 1) = PV3.Minutenertrag(i + 1) / 2
                    PV3.Minutenertrag(i) = PV3.Minutenertrag(i + 1)
                Else
                    PV2.Minutenertrag(i) = 0
                    PV3.Minutenertrag(i) = 0
                End If
            End If
            If PV3.Minutenertrag(i) > Val(TB_L1Anlagenleistung.Text.Replace(",", ".")) * 1000 * 2 Then
                PV2.Minutenertrag(i) = 0
                PV3.Minutenertrag(i) = 0
            End If
        Next
        i = 288
        If PV3.Minutenertrag(i) < 0 Then
            If PV3.Minutenertrag(i - 1) >= -PV3.Minutenertrag(i) Then
                PV3.Minutenertrag(i - 1) = PV3.Minutenertrag(i - 1) + PV3.Minutenertrag(i)
                PV3.Minutenertrag(i - 1) = PV3.Minutenertrag(i - 1) / 2
                PV3.Minutenertrag(i) = PV3.Minutenertrag(i - 1)
            Else
                PV2.Minutenertrag(i) = 0
                PV3.Minutenertrag(i) = 0
            End If
        End If
        If PV3.Minutenertrag(i) > Val(TB_L1Anlagenleistung.Text.Replace(",", ".")) * 1000 * 2 Then
            PV2.Minutenertrag(i) = 0
            PV3.Minutenertrag(i) = 0
        End If



        'Tageskorrektur
        For i = 1 To kwAZ
            If Val(yearBox.Text) = kw(i).j And Val(monthBox.Text) = kw(i).m And kw(i).t > 0 Then
                Select Case kw(i).a
                    Case "PV1"
                        PV1.Tagesertrag(kw(i).t) = kw(i).w
                        PV1.Monatsertrag(kw(i).m) = 0
                        For j = 1 To 31
                            PV1.Monatsertrag(kw(i).m) = PV1.Monatsertrag(kw(i).m) + PV1.Tagesertrag(j)
                        Next
                    Case "PV2"
                        PV2.Tagesertrag(kw(i).t) = kw(i).w
                        PV2.Monatsertrag(kw(i).m) = 0
                        For j = 1 To 31
                            PV2.Monatsertrag(kw(i).m) = PV2.Monatsertrag(kw(i).m) + PV2.Tagesertrag(j)
                        Next
                    Case "PV3"
                        PV3.Tagesertrag(kw(i).t) = kw(i).w
                        PV3.Monatsertrag(kw(i).m) = 0
                        For j = 1 To 31
                            PV3.Monatsertrag(kw(i).m) = PV3.Monatsertrag(kw(i).m) + PV3.Tagesertrag(j)
                        Next
                End Select
            End If
        Next

        'Monatskorrektur
        For i = 1 To kwAZ
            If Val(yearBox.Text) = kw(i).j Then
                If kw(i).t = 0 Then
                    Select Case kw(i).a
                        Case "PV1"
                            PV1.Monatsertrag(kw(i).m) = kw(i).w
                        Case "PV2"
                            PV2.Monatsertrag(kw(i).m) = kw(i).w
                        Case "PV3"
                            PV3.Monatsertrag(kw(i).m) = kw(i).w
                    End Select
                End If
            End If
        Next
    End Sub

    Private Sub DatenkorrekturwerteEinlesen()
        'Dim f As String = Environment.CurrentDirectory & "\Korrekturwerte.txt"
        Dim f As String = saveLocation.Text & "Korrekturwerte.txt"
        If File.Exists(f) Then
            Using MyReader As New Microsoft.VisualBasic.FileIO.TextFieldParser(f)
                MyReader.TextFieldType = FileIO.FieldType.Delimited
                MyReader.SetDelimiters(".", " ")
                Dim currentRow As String()
                kwAZ = 0

                While Not MyReader.EndOfData
                    Try
                        currentRow = MyReader.ReadFields()
                        If currentRow(0).Substring(0, 1) <> "'" Then
                            kwAZ = kwAZ + 1
                        End If
                    Catch ex As Microsoft.VisualBasic.FileIO.MalformedLineException
                        MsgBox("Line " & ex.Message & _
                        "is not valid and will be skipped.")
                    End Try
                End While
                ReDim kw(kwAZ)
            End Using

            Using MyReader As New Microsoft.VisualBasic.FileIO.TextFieldParser(f)
                MyReader.TextFieldType = FileIO.FieldType.Delimited
                MyReader.SetDelimiters(".", " ")
                Dim currentRow As String()
                Dim i As Integer

                i = 1

                While Not MyReader.EndOfData
                    Try
                        currentRow = MyReader.ReadFields()

                        If currentRow(0).Substring(0, 1) <> "'" Then
                            kw(i).t = CInt(currentRow(0))
                            kw(i).m = CInt(currentRow(1))
                            kw(i).j = CInt(currentRow(2))
                            kw(i).a = currentRow(3)
                            currentRow(4) = currentRow(4).Replace(",", ".")
                            kw(i).w = Val(currentRow(4))
                            i = i + 1
                        End If

                    Catch ex As  _
                    Microsoft.VisualBasic.FileIO.MalformedLineException
                        MsgBox("Line " & ex.Message & _
                        "is not valid and will be skipped.")
                    End Try
                End While
            End Using
        End If
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
       Dim t1 As DateTime = DateTime.Parse(dayBox.Text & "-" & monthBox.Text & "-" & yearBox.Text)

        t1 = t1.AddDays(-1)

        dayBox.Text = t1.Day.ToString
        monthBox.Text = t1.Month.ToString
        yearBox.Text = t1.Year.ToString

        Grafikaktualisierung()
        statusBox.Text = ""
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        Dim t1 As DateTime = DateTime.Parse(dayBox.Text & "-" & monthBox.Text & "-" & yearBox.Text)

        t1 = t1.AddDays(1)

        dayBox.Text = t1.Day.ToString
        monthBox.Text = t1.Month.ToString
        yearBox.Text = t1.Year.ToString

        Grafikaktualisierung()
        statusBox.Text = ""
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles minuteRefreshButton.Click
        MinutenwerteTagAktualisieren()
        ' Minutenwerte Tag aktualisieren
    End Sub

    Private Sub MinutenwerteTagAktualisieren()
        If CB_L1PVLogEinlesen.Checked Then 'Falls die Checkbox "PV-Log einlesen" angeklickt ist, werden die Daten von PV-Log geholt
            If WebStatus = "Idle" Then
                minuteRefreshButton.Enabled = False
                Button10.Enabled = False
                Button11.Enabled = False
                dayBox.Enabled = False
                If Not (File.Exists(saveLocation.Text & PV1.PVLogNummer.ToString & "_" & yearBox.Text.ToString & "_" & monthBox.Text.ToString & "_" & dayBox.Text.ToString & "_min.txt") And File.Exists(saveLocation.Text & PV2.PVLogNummer.ToString & "_" & yearBox.Text.ToString & "_" & monthBox.Text.ToString & "_" & dayBox.Text.ToString & "_min.txt") And File.Exists(saveLocation.Text & PV3.PVLogNummer.ToString & "_" & yearBox.Text.ToString & "_" & monthBox.Text.ToString & "_" & dayBox.Text.ToString & "_min.txt")) Or Not CheckBox2.Checked Then
                    Dim dtemp As Date
                    dtemp.AddDays(CInt(dayBox.Text) - dtemp.Day)
                    dtemp.AddMonths(CInt(monthBox.Text) - dtemp.Month)
                    dtemp.AddYears(CInt(yearBox.Text) - dtemp.Year)
                    If dtemp.CompareTo(PV1.Aktualisierungsstand) <= 0 Or Not CheckBox2.Checked Then
                        If WebStatus = "Idle" Then
                            WebStatus = "Minutenwerte"
                            Status = "Minutenwerte einlesen"
                            statusBox.Text = Status
                            refreshButton.Enabled = False
                            getMinFromPVLog(PV1.PVLogNummer, PV1.PVLogNummer)
                            getMinFromPVLog(PV2.PVLogNummer, PV2.PVLogNummer)
                            getMinFromPVLog(PV3.PVLogNummer, PV3.PVLogNummer)
                            Status = "Minutenwerte übertragen."
                            WebStatus = "Idle"
                            statusBox.Text = Status
                            Grafikaktualisierung()
                            minuteRefreshButton.Enabled = True
                            refreshButton.Enabled = True
                            Button10.Enabled = True
                            Button11.Enabled = True
                            dayBox.Enabled = True
                            Label11.Text = Now.ToString
                        End If
                    Else
                        MessageBox.Show("Minutenwerte sind erst nach erfolgreicher Aktualisierung der Tageswerte für diesen Tag verfügbar")
                    End If
                    minuteRefreshButton.Enabled = True
                    Button10.Enabled = True
                    Button11.Enabled = True
                    dayBox.Enabled = True
                    Exit Sub
                End If

                MinutenwerteAnzeigen()

                minuteRefreshButton.Enabled = True
                Button10.Enabled = True
                Button11.Enabled = True
                dayBox.Enabled = True
            End If
        Else
            'hier einlesen
            Status = "Minutenwerte abrufen."
            statusBox.Text = Status
            Select Case CB_L1_Quelle.SelectedIndex ' JAU 09.01.2013
                Case 0 'S0 Impulse
                    getMinFromFreeSol(TB_L1FreeSolURL.Text & "/minutes.js", PV1.PVLogNummer, "P")
                Case 1 'SML 1.8.0
                    getMinFromFreeSol(TB_L1FreeSolURL.Text & "/" & TextBox1.Text & "_b.js", PV1.PVLogNummer, "P")
                Case Else 'SML 2.8.0
                    getMinFromFreeSol(TB_L1FreeSolURL.Text & "/" & TextBox1.Text & "_e.js", PV1.PVLogNummer, "P")
            End Select
            Status = "Erzeugung erfolgreich abgerufen."
            statusBox.Text = Status
            Select Case CB_L2_Quelle.SelectedIndex ' JAU 09.01.2013
                Case 0 'S0 Impulse
                    getMinFromFreeSol(TB_L2FreeSolURL.Text & "/minutes.js", PV2.PVLogNummer, "B")
                Case 1 'SML 1.8.0
                    getMinFromFreeSol(TB_L2FreeSolURL.Text & "/" & TextBox1.Text & "_b.js", PV2.PVLogNummer, "B")
                Case Else 'SML 2.8.0
                    getMinFromFreeSol(TB_L2FreeSolURL.Text & "/" & TextBox1.Text & "_e.js", PV2.PVLogNummer, "B")
            End Select
            Status = "Bezug erfolgreich abgerufen."
            statusBox.Text = Status
            Select Case CB_L3_Quelle.SelectedIndex ' JAU 09.01.2013
                Case 0 'S0 Impulse
                    getMinFromFreeSol(TB_L3FreeSolURL.Text & "/minutes.js", PV3.PVLogNummer, "E")
                Case 1 'SML 1.8.0
                    getMinFromFreeSol(TB_L3FreeSolURL.Text & "/" & TextBox1.Text & "_b.js", PV3.PVLogNummer, "E")
                Case Else 'SML 2.8.0
                    getMinFromFreeSol(TB_L3FreeSolURL.Text & "/" & TextBox1.Text & "_e.js", PV3.PVLogNummer, "E")
            End Select
            Status = "Einspeisung erfolgreich abgerufen."
            statusBox.Text = Status

            MinutenwerteAnzeigen()
        End If
    End Sub

    Private Sub MinutenwerteVortagAktualisieren()
        Status = "Minutenwerte abrufen."
        statusBox.Text = Status
        Select Case CB_L1_Quelle.SelectedIndex ' JAU 09.01.2013
            Case 0 'S0 Impulse
                getMinFromFreeSol(TB_L1FreeSolURL.Text & "/minutes.js", PV1.PVLogNummer, "P")
            Case 1 'SML 1.8.0
                getMinFromFreeSol(TB_L1FreeSolURL.Text & "/" & TextBox1.Text & "_b.js", PV1.PVLogNummer, "P")
            Case Else 'SML 2.8.0
                getMinFromFreeSol(TB_L1FreeSolURL.Text & "/" & TextBox1.Text & "_e.js", PV1.PVLogNummer, "P")
        End Select
        Status = "Erzeugung erfolgreich abgerufen."
        statusBox.Text = Status
        Select Case CB_L2_Quelle.SelectedIndex ' JAU 09.01.2013
            Case 0 'S0 Impulse
                getMinFromFreeSol(TB_L2FreeSolURL.Text & "/minutes.js", PV2.PVLogNummer, "B")
            Case 1 'SML 1.8.0
                getMinFromFreeSol(TB_L2FreeSolURL.Text & "/" & TextBox1.Text & "_b.js", PV2.PVLogNummer, "B")
            Case Else 'SML 2.8.0
                getMinFromFreeSol(TB_L2FreeSolURL.Text & "/" & TextBox1.Text & "_e.js", PV2.PVLogNummer, "B")
        End Select
        Status = "Bezug erfolgreich abgerufen."
        statusBox.Text = Status
        Select Case CB_L3_Quelle.SelectedIndex ' JAU 09.01.2013
            Case 0 'S0 Impulse
                getMinFromFreeSol(TB_L3FreeSolURL.Text & "/minutes.js", PV3.PVLogNummer, "E")
            Case 1 'SML 1.8.0
                getMinFromFreeSol(TB_L3FreeSolURL.Text & "/" & TextBox1.Text & "_b.js", PV3.PVLogNummer, "E")
            Case Else 'SML 2.8.0
                getMinFromFreeSol(TB_L3FreeSolURL.Text & "/" & TextBox1.Text & "_e.js", PV3.PVLogNummer, "E")
        End Select
        Status = "Einspeisung erfolgreich abgerufen."
        statusBox.Text = Status

        Status = "Minutenwerte Vortag abrufen."
        statusBox.Text = Status
        Select Case CB_L1_Quelle.SelectedIndex ' JAU 09.01.2013
            Case 0 'S0 Impulse
                getMinFromFreeSol(TB_L1FreeSolURL.Text & "/minutesv.js", PV1.PVLogNummer, "P")
            Case 1 'SML 1.8.0
                getMinFromFreeSol(TB_L1FreeSolURL.Text & "/" & TextBox1.Text & "_bv.js", PV1.PVLogNummer, "P")
            Case Else 'SML 2.8.0
                getMinFromFreeSol(TB_L1FreeSolURL.Text & "/" & TextBox1.Text & "_ev.js", PV1.PVLogNummer, "P")
        End Select
        Status = "Erzeugung Vortag erfolgreich abgerufen."
        statusBox.Text = Status
        Select Case CB_L2_Quelle.SelectedIndex ' JAU 09.01.2013
            Case 0 'S0 Impulse
                getMinFromFreeSol(TB_L2FreeSolURL.Text & "/minutesv.js", PV2.PVLogNummer, "B")
            Case 1 'SML 1.8.0
                getMinFromFreeSol(TB_L2FreeSolURL.Text & "/" & TextBox1.Text & "_bv.js", PV2.PVLogNummer, "B")
            Case Else 'SML 2.8.0
                getMinFromFreeSol(TB_L2FreeSolURL.Text & "/" & TextBox1.Text & "_ev.js", PV2.PVLogNummer, "B")
        End Select
        Status = "Bezug Vortag erfolgreich abgerufen."
        statusBox.Text = Status
        Select Case CB_L3_Quelle.SelectedIndex ' JAU 09.01.2013
            Case 0 'S0 Impulse
                getMinFromFreeSol(TB_L3FreeSolURL.Text & "/minutesv.js", PV3.PVLogNummer, "E")
            Case 1 'SML 1.8.0
                getMinFromFreeSol(TB_L3FreeSolURL.Text & "/" & TextBox1.Text & "_bv.js", PV3.PVLogNummer, "E")
            Case Else 'SML 2.8.0
                getMinFromFreeSol(TB_L3FreeSolURL.Text & "/" & TextBox1.Text & "_ev.js", PV3.PVLogNummer, "E")
        End Select
        Status = "Einspeisung Vortag erfolgreich abgerufen."
        statusBox.Text = Status

        MinutenwerteAnzeigen()


    End Sub

    Private Sub MinutenwerteAnzeigen()
        Dim letzteMinute As Integer
        DatenfileFehlt = False
        Dim basisverbrauch As Double

        Minutenwerte_EinlesenAusFile()
        For i = 288 To 1 Step -1
            If PV1.Minutenertrag(i) > 0 Or PV2.Minutenertrag(i) > 0 Or PV3.Minutenertrag(i) > 0 Then
                letzteMinute = i
                i = 1
            End If
        Next

        If DatenfileFehlt And CheckBox2.Checked Then
            minuteChart.Titles.Clear()
            minuteChart.Series.Clear()
            minuteChart.Titles.Add(dayBox.Text & "." & monthBox.Text & "." & yearBox.Text)
            minuteChart.Titles(0).Font = New Drawing.Font("Arial", 16)
            minuteChart.Titles.Add("Datenfile fehlt")
        Else
            minuteChart.Series.Clear()
            minuteChart.Series.Add(TB_L1Name.Text)
            minuteChart.Series.Add(TB_L2Name.Text)
            minuteChart.Series.Add(TB_L3Name.Text)
            minuteChart.Series.Add("Verbrauch")
            minuteChart.Series.Add("Eigenverbrauch")
            minuteChart.Series.Add("Basisverbrauch")
            minuteChart.Series(TB_L1Name.Text).Color = Color.Orange
            minuteChart.Series(TB_L2Name.Text).Color = Color.Blue
            minuteChart.Series(TB_L3Name.Text).Color = Color.LimeGreen
            minuteChart.Series("Verbrauch").Color = Color.Black
            minuteChart.Series("Eigenverbrauch").Color = Color.Red
            minuteChart.Series("Basisverbrauch").Color = Color.Yellow
            minuteChart.ChartAreas(0).AxisX.Title = "Zeit (Darstellbereich 0.00 bis 24.00 Uhr)"

            minuteChart.ChartAreas(0).AxisX.Interval = 24
            minuteChart.ChartAreas(0).AxisX.Maximum = 288
            Dim lc As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc.Text = "12.00"  'Standardformatzeichen für Tag/Monat
            lc.FromPosition = 134    'Label Start-Koordinate auf aktueller X-Achse
            lc.ToPosition = 154
            minuteChart.ChartAreas(0).AxisX.CustomLabels.Add(lc)

            Dim lc2 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc2.Text = "08.00"  'Standardformatzeichen für Tag/Monat
            lc2.FromPosition = 86    'Label Start-Koordinate auf aktueller X-Achse
            lc2.ToPosition = 106
            minuteChart.ChartAreas(0).AxisX.CustomLabels.Add(lc2)

            Dim lc3 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc3.Text = "04.00"  'Standardformatzeichen für Tag/Monat
            lc3.FromPosition = 38    'Label Start-Koordinate auf aktueller X-Achse
            lc3.ToPosition = 58
            minuteChart.ChartAreas(0).AxisX.CustomLabels.Add(lc3)

            Dim lc4 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc4.Text = "00.00"  'Standardformatzeichen für Tag/Monat
            lc4.FromPosition = -10    'Label Start-Koordinate auf aktueller X-Achse
            lc4.ToPosition = 10
            minuteChart.ChartAreas(0).AxisX.CustomLabels.Add(lc4)

            Dim lc5 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc5.Text = "16.00"  'Standardformatzeichen für Tag/Monat
            lc5.FromPosition = 182    'Label Start-Koordinate auf aktueller X-Achse
            lc5.ToPosition = 212
            minuteChart.ChartAreas(0).AxisX.CustomLabels.Add(lc5)

            Dim lc6 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc6.Text = "20.00"  'Standardformatzeichen für Tag/Monat
            lc6.FromPosition = 230    'Label Start-Koordinate auf aktueller X-Achse
            lc6.ToPosition = 250
            minuteChart.ChartAreas(0).AxisX.CustomLabels.Add(lc6)

            Dim lc7 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc7.Text = "24.00"  'Standardformatzeichen für Tag/Monat
            lc7.FromPosition = 288 - 10    'Label Start-Koordinate auf aktueller X-Achse
            lc7.ToPosition = 288 + 10
            minuteChart.ChartAreas(0).AxisX.CustomLabels.Add(lc7)




            minuteChart.ChartAreas(0).AxisY.Title = "aktuelle Leistung in W"
            minuteChart.Series(TB_L2Name.Text).ChartType = DataVisualization.Charting.SeriesChartType.Line
            minuteChart.Series(TB_L3Name.Text).ChartType = DataVisualization.Charting.SeriesChartType.Line
            minuteChart.Series(TB_L1Name.Text).ChartType = DataVisualization.Charting.SeriesChartType.Line
            minuteChart.Series("Verbrauch").ChartType = DataVisualization.Charting.SeriesChartType.Line
            minuteChart.Series("Eigenverbrauch").ChartType = DataVisualization.Charting.SeriesChartType.Line
            minuteChart.Series("Basisverbrauch").ChartType = DataVisualization.Charting.SeriesChartType.Line


            basisverbrauch = 0
            For i = 12 To 6 * 12
                basisverbrauch += PV2.Minutenertrag(i)
            Next
            basisverbrauch = basisverbrauch / (72 - 11)


            '---
            For i = 1 To letzteMinute
                minuteChart.Series(TB_L1Name.Text).Points.AddY(PV1.Minutenertrag(i))
                minuteChart.Series(TB_L2Name.Text).Points.AddY(PV2.Minutenertrag(i))
                minuteChart.Series(TB_L3Name.Text).Points.AddY(PV3.Minutenertrag(i))
                minuteChart.Series("Verbrauch").Points.AddY(PV2.Minutenertrag(i) + PV1.Minutenertrag(i) - PV3.Minutenertrag(i)) 'Bezug + Solar-Einspeisung
                minuteChart.Series("Eigenverbrauch").Points.AddY(PV1.Minutenertrag(i) - PV3.Minutenertrag(i)) 'Solar-Einspeisung
                minuteChart.Series("Basisverbrauch").Points.AddY(basisverbrauch) 'Solar-Einspeisung
            Next
            minuteChart.Titles.Clear()
            minuteChart.Titles.Add(dayBox.Text & "." & monthBox.Text & "." & yearBox.Text)
            minuteChart.Titles(0).Font = New Drawing.Font("Arial", 16)

            If CheckedListBox1.GetItemChecked(0) = False Then
                minuteChart.Series(TB_L1Name.Text).Color = Color.Transparent
            End If

            If CheckedListBox1.GetItemChecked(1) = False Then
                minuteChart.Series(TB_L2Name.Text).Color = Color.Transparent
            End If

            If CheckedListBox1.GetItemChecked(2) = False Then
                minuteChart.Series(TB_L3Name.Text).Color = Color.Transparent
            End If

            If CheckedListBox1.GetItemChecked(3) = False Then
                minuteChart.Series("Verbrauch").Color = Color.Transparent
            End If

            If CheckedListBox1.GetItemChecked(4) = False Then
                minuteChart.Series("Eigenverbrauch").Color = Color.Transparent
            End If

            If CheckedListBox1.GetItemChecked(5) = False Then
                minuteChart.Series("Basisverbrauch").Color = Color.Transparent
            End If

            minuteChart.Series(TB_L1Name.Text).Points.Invalidate()
            minuteChart.Series(TB_L2Name.Text).Points.Invalidate()
            minuteChart.Series(TB_L3Name.Text).Points.Invalidate()
            minuteChart.Series("Verbrauch").Points.Invalidate()
            minuteChart.Series("Eigenverbrauch").Points.Invalidate()
            minuteChart.Series("Basisverbrauch").Points.Invalidate()




        End If
        Dim d As Double
        Dim solar As Double
        Dim verbrauch As Double
        Dim bezug As Double
        Dim einspeis As Double
        Dim Eigenverbrauch As Double


        d = 0
        For Each d1 In PV1.Minutenertrag
            d = d + d1
        Next
        d = d - PV1.Minutenertrag(0)
        d = d / 12
        solar = d
        Label27.Text = d.ToString


        d = 0
        For Each d1 In PV2.Minutenertrag
            d = d + d1
        Next
        d = d - PV2.Minutenertrag(0)
        d = d / 12
        bezug = d
        Label28.Text = d.ToString

        d = 0
        For Each d1 In PV3.Minutenertrag
            d = d + d1
        Next
        d = d - PV3.Minutenertrag(0)
        d = d / 12
        einspeis = d
        Label31.Text = d.ToString

        verbrauch = solar + bezug - einspeis

        Label33.Text = verbrauch.ToString
        Eigenverbrauch = solar - einspeis

        If solar <> 0 Then
            Label36.Text = ((Eigenverbrauch / solar) * 100).ToString("##.#") & "%"
        Else
            Label36.Text = "nicht berechenbar"
        End If

        If verbrauch <> 0 Then
            Label37.Text = ((Eigenverbrauch / verbrauch) * 100).ToString("##0.#") & "%"
        Else
            Label37.Text = "nicht berechenbar"
        End If

        Label38.Text = (solar - einspeis).ToString
        Label42.Text = (24 * basisverbrauch).ToString("#####")
        Label46.Text = basisverbrauch.ToString("####") & " W"


        Label48.Text = (PV1.Minutenertrag(letzteMinute)).ToString("####") & " W"

        If verbrauch <> 0 Then
            Label45.Text = ((24 * basisverbrauch / verbrauch) * 100).ToString("##0.#") & "%"
        Else
            Label45.Text = "nicht berechenbar"
        End If





    End Sub

    Private Sub Minutenwerte_EinlesenAusFile()
        For i = 0 To 288
            PV2.Minutenertrag(i) = 0
            PV3.Minutenertrag(i) = 0
            PV1.Minutenertrag(i) = 0
        Next

        Dim fileending = "_" & yearBox.Text.ToString & "_" & monthBox.Text.ToString & "_" & dayBox.Text.ToString & "_min.txt"
        Try
            PV1.Minutenertrag = readMinFileToArray("PVL_P_" & PV1.PVLogNummer & fileending, 288, -1, 5)
        Catch ex As FileNotFoundException
            DatenfileFehlt = True
        End Try
        Try
            PV2.Minutenertrag = readMinFileToArray("PVL_B_" & PV2.PVLogNummer & fileending, 288, -1, 5)
        Catch ex As FileNotFoundException
            DatenfileFehlt = True
        End Try
        Try
            PV3.Minutenertrag = readMinFileToArray("PVL_E_" & PV3.PVLogNummer & fileending, 288, -1, 5)
        Catch ex As FileNotFoundException
            DatenfileFehlt = True
        End Try
        Datenkorrektur()
    End Sub

    Private Sub TextBox11_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dayBox.Leave
        Dim t As Integer = DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text))
        If CInt(dayBox.Text) < 1 Or Val(dayBox.Text) > t Then
            dayBox.Text = "1"
        End If
    End Sub



    Private Sub TextBox11_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles dayBox.KeyDown
        If e.KeyCode = Keys.Enter Then
            e.SuppressKeyPress = True
            Dim t As Integer = DateTime.DaysInMonth(CInt(yearBox.Text), CInt(monthBox.Text))
            If Val(dayBox.Text) < 1 Or Val(dayBox.Text) > t Then
                dayBox.Text = "1"
            End If
            Grafikaktualisierung()
        End If
    End Sub


    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        'Ganzen Monat aktualisieren

        If CheckBox8.Checked Then
            Dim dateiliste As New List(Of String)
            Dim remoteUri As String = TextBox13.Text
            Dim fileName As String
            Dim fileNameDir As String

            ' Directory lesen
            Dim myStringWebResource As String = Nothing
            Dim myWebClient As New WebClient()
            fileName = "directory.txt"
            myStringWebResource = remoteUri
            myWebClient.Headers.Add(Net.HttpRequestHeader.UserAgent, ".Net client") '2013-02-23 Fehlerbehebung Netzzugriff; nach http://www.vbdotnetforums.com/net-sockets/45516-getting-403-forbidden-error-valid-public-web-page.html
            myWebClient.DownloadFile(myStringWebResource, saveLocation.Text + fileName)
            statusBox.Text = "Directory lesen"

            Dim lines As String()
            Dim stringSeparators() As String = {"<a href="""}
            Dim counter As Integer = 0
            If (File.Exists(saveLocation.Text & "directory.txt")) Then
                fileNameDir = saveLocation.Text & "directory.txt"
                lines = File.ReadAllLines(fileNameDir)
                Dim elements As String()
                For Each line In lines
                    counter = counter + 1
                    elements = line.Split(stringSeparators, StringSplitOptions.None)
                    If elements.Length > 1 Then
                        elements = elements(1).Split(">"c, """"c)
                        If Not elements(0).Contains("?") And Not elements(0).Contains("/") Then 'Nur Minutenfiles
                            If Val(Mid(elements(0), 1, 2)) = Val(yearBox.Text) - 2000 And Val(Mid(elements(0), 3, 2)) = Val(monthBox.Text) Then ' nur minutenfiles des aktuellen monats
                                dateiliste.Add(elements(0))
                            End If
                        End If
                    End If
                Next
            End If


            For Each fileName In dateiliste
                statusBox.Text = fileName
                statusBox.Refresh()
                ' hier lesen
                If fileName.Contains("minutesv.") Then
                    getMinFromFreeSol(remoteUri & fileName, PV1.PVLogNummer, "P")
                ElseIf fileName.Contains("_bv.js") Then
                    getMinFromFreeSol(remoteUri & fileName, PV2.PVLogNummer, "B")
                ElseIf fileName.Contains("_ev.js") Then
                    getMinFromFreeSol(remoteUri & fileName, PV3.PVLogNummer, "E")
                End If
            Next
            statusBox.Text = "Datenaktualisierung aus Portal fertig!"

        End If
    End Sub


    Private Sub RadioButton4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton4.CheckedChanged
        If RadioButton4.Checked Then
            RadioButton5.Checked = False
            RadioButton6.Checked = False
            Anlage = 1
        ElseIf Anlage = 1 Then
            Anlage = 0
        End If
    End Sub
    Private Sub RadioButton5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton5.CheckedChanged
        If RadioButton5.Checked Then
            RadioButton4.Checked = False
            RadioButton6.Checked = False
            Anlage = 2
        ElseIf Anlage = 2 Then
            Anlage = 0
        End If
    End Sub
    Private Sub RadioButton6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton6.CheckedChanged
        If RadioButton6.Checked Then
            RadioButton5.Checked = False
            RadioButton4.Checked = False
            Anlage = 3
        ElseIf Anlage = 3 Then
            Anlage = 0
        End If
    End Sub



    Private Sub DateTimePicker1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DateTimePicker1.ValueChanged, DateTimePicker2.ValueChanged, DateTimePicker3.ValueChanged
        '  MinutenvergleichAktualisieren()
        'DateTimePicker1.Text = DateTimePicker1.Value.ToString
        'DateTimePicker2.Text = DateTimePicker2.Value.ToString
        'DateTimePicker3.Text = DateTimePicker3.Value.ToString
    End Sub

    Private Sub MinutenvergleichAktualisieren()

        '   If (DateTimePicker1.Text = DateTimePicker2.Text And DateTimePicker1.Value <> Today.Date) Or (DateTimePicker1.Text = DateTimePicker3.Text And DateTimePicker1.Value <> Today.Date) Or (DateTimePicker3.Text = DateTimePicker2.Text And DateTimePicker2.Value <> Today.Date) Then
        '     MessageBox.Show("Fehler: Zwei gleiche Tage gewählt!")
        'Else


        If DateTimePicker1.Value <> Today.Date Or DateTimePicker2.Value <> Today.Date Or DateTimePicker3.Value <> Today.Date Then
            minuteCompareChart.Series.Clear()

            minuteCompareChart.ChartAreas(0).AxisX.Title = "Zeit (Darstellbereich 00.00 bis 24.00 Uhr)"
            minuteCompareChart.ChartAreas(0).AxisY.Title = "Aktuelle Leistung in W"
            minuteCompareChart.Titles.Clear()
            minuteCompareChart.Titles.Add("Vergleich verschiedener Tage")
            minuteCompareChart.Titles(0).Font = New Drawing.Font("Arial", 16)
            '         minuteCompareChart.Titles(0).Alignment = ContentAlignment.TopCenter

            minuteCompareChart.ChartAreas(0).AxisX.Interval = 24
            minuteCompareChart.ChartAreas(0).AxisX.Maximum = 288

            Dim lc As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc.Text = "12.00"  'Standardformatzeichen für Tag/Monat
            lc.FromPosition = 134    'Label Start-Koordinate auf aktueller X-Achse
            lc.ToPosition = 154
            minuteCompareChart.ChartAreas(0).AxisX.CustomLabels.Add(lc)

            Dim lc2 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc2.Text = "08.00"  'Standardformatzeichen für Tag/Monat
            lc2.FromPosition = 86    'Label Start-Koordinate auf aktueller X-Achse
            lc2.ToPosition = 106
            minuteCompareChart.ChartAreas(0).AxisX.CustomLabels.Add(lc2)

            Dim lc3 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc3.Text = "04.00"  'Standardformatzeichen für Tag/Monat
            lc3.FromPosition = 38    'Label Start-Koordinate auf aktueller X-Achse
            lc3.ToPosition = 58
            minuteCompareChart.ChartAreas(0).AxisX.CustomLabels.Add(lc3)

            Dim lc4 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc4.Text = "00.00"  'Standardformatzeichen für Tag/Monat
            lc4.FromPosition = -10    'Label Start-Koordinate auf aktueller X-Achse
            lc4.ToPosition = 10
            minuteCompareChart.ChartAreas(0).AxisX.CustomLabels.Add(lc4)

            Dim lc5 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc5.Text = "16.00"  'Standardformatzeichen für Tag/Monat
            lc5.FromPosition = 182    'Label Start-Koordinate auf aktueller X-Achse
            lc5.ToPosition = 212
            minuteCompareChart.ChartAreas(0).AxisX.CustomLabels.Add(lc5)

            Dim lc6 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc6.Text = "20.00"  'Standardformatzeichen für Tag/Monat
            lc6.FromPosition = 230    'Label Start-Koordinate auf aktueller X-Achse
            lc6.ToPosition = 250
            minuteCompareChart.ChartAreas(0).AxisX.CustomLabels.Add(lc6)

            Dim lc7 As New System.Windows.Forms.DataVisualization.Charting.CustomLabel()
            lc7.Text = "24.00"  'Standardformatzeichen für Tag/Monat
            lc7.FromPosition = 288 - 10    'Label Start-Koordinate auf aktueller X-Achse
            lc7.ToPosition = 288 + 10
            minuteCompareChart.ChartAreas(0).AxisX.CustomLabels.Add(lc7)

            '+++
            If DateTimePicker1.Value <> Today.Date.AddDays(1) Then
                minuteCompareChart.Series.Add("A_" + DateTimePicker1.Value.ToString)
                minuteCompareChart.Series("A_" + DateTimePicker1.Value.ToString).ChartType = DataVisualization.Charting.SeriesChartType.Line
                DatenfileFehlt = False
                Minutenvergleich_PV1_EinlesenAusFile(DateTimePicker1.Value, Anlage)
                For i = 1 To 288 '300 To 1200 wag ! 288<>1200
                    minuteCompareChart.Series("A_" + DateTimePicker1.Value.ToString).Points.AddY(Minutenvergleich(i)) '* 12)
                Next
                minuteCompareChart.Series("A_" + DateTimePicker1.Value.ToString).Points.Invalidate()
            End If

            If DateTimePicker2.Value <> Today.Date.AddDays(1) Then
                minuteCompareChart.Series.Add("B_" + DateTimePicker2.Value.ToString)
                minuteCompareChart.Series("B_" + DateTimePicker2.Value.ToString).ChartType = DataVisualization.Charting.SeriesChartType.Line
                DatenfileFehlt = False
                Minutenvergleich_PV1_EinlesenAusFile(DateTimePicker2.Value, Anlage)
                For i = 1 To 288 '300 To 1200
                    minuteCompareChart.Series("B_" + DateTimePicker2.Value.ToString).Points.AddY(Minutenvergleich(i)) '* 12) '/  PV2.Anlagenleistung)
                Next
                minuteCompareChart.Series("B_" + DateTimePicker2.Value.ToString).Points.Invalidate()
            End If

            If DateTimePicker3.Value <> Today.Date.AddDays(1) Then
                minuteCompareChart.Series.Add("C_" + DateTimePicker3.Value.ToString)
                minuteCompareChart.Series("C_" + DateTimePicker3.Value.ToString).ChartType = DataVisualization.Charting.SeriesChartType.Line
                DatenfileFehlt = False
                Minutenvergleich_PV1_EinlesenAusFile(DateTimePicker3.Value, Anlage)
                For i = 1 To 288 '300 To 1200
                    minuteCompareChart.Series("C_" + DateTimePicker3.Value.ToString).Points.AddY(Minutenvergleich(i)) '* 12) ' /  PV3.Anlagenleistung)
                Next
                minuteCompareChart.Series("C_" + DateTimePicker3.Value.ToString).Points.Invalidate()
            End If



        End If
        '  End If


    End Sub

    Private Sub Minutenvergleich_PV1_EinlesenAusFile(ByVal Datum As Date, ByVal Anlage As Integer)
        Dim Jahr As String = Datum.Year.ToString
        Dim Monat As String = Datum.Month.ToString
        Dim Tag As String = Datum.Day.ToString
        Dim Anlagenstring As String
        Dim Vergleichsfaktor As Double

        Select Case Anlage
            Case 1 ' Solar
                Anlagenstring = "PVL_P_" + PV1.PVLogNummer.ToString & "_"
                Vergleichsfaktor = 1 '1 / PV1.Anlagenleistung
            Case 2 ' Bezug
                Anlagenstring = "PVL_B_" + PV2.PVLogNummer.ToString & "_"
                Vergleichsfaktor = 1 '1 / PV2.Anlagenleistung
            Case 3 ' Einspeis
                Anlagenstring = "PVL_E_" + PV3.PVLogNummer.ToString & "_"
                Vergleichsfaktor = 1 '1 / PV3.Anlagenleistung
            Case Else
                Anlagenstring = "Fehler"
        End Select

        For i = 0 To 288
            Minutenvergleich(i) = 0
        Next

        If File.Exists(saveLocation.Text & Anlagenstring & Jahr & "_" & Monat & "_" & Tag & "_min.txt") Then
            Using MyReader As New Microsoft.VisualBasic.FileIO.TextFieldParser(saveLocation.Text & Anlagenstring & Jahr & "_" & Monat & "_" & Tag & "_min.txt")
                MyReader.TextFieldType = FileIO.FieldType.Delimited
                MyReader.SetDelimiters(";")
                Dim currentRow As String()
                Dim i As Integer

                For i = 1 To 4
                    Try
                        currentRow = MyReader.ReadFields()
                    Catch ex As  _
                                    Microsoft.VisualBasic.FileIO.MalformedLineException
                        MsgBox("Line " & ex.Message & _
                        "is not valid and will be skipped.")
                    End Try
                Next
                i = 1
                While Not MyReader.EndOfData
                    Try
                        currentRow = MyReader.ReadFields()
                        'Dim currentField As String
                        If Val(currentRow(0)) > 0 Then
                            If currentRow(5) <> "" Then
                                Minutenvergleich(i) = CDbl(currentRow(5)) * Vergleichsfaktor
                            Else
                                Minutenvergleich(i) = 0
                            End If
                        End If
                        i = i + 1
                    Catch ex As  _
                    Microsoft.VisualBasic.FileIO.MalformedLineException
                        MsgBox("Line " & ex.Message & _
                        "is not valid and will be skipped.")
                    End Try
                End While
            End Using
            Datenkorrektur()
        Else
            DatenfileFehlt = True
        End If

    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        minuteCompareChart.Series.Clear()
        MinutenvergleichAktualisieren()
    End Sub

    Private Function getStreamFromURL(ByVal url As String, ByRef Fehler As Boolean) As StreamReader
        'Return New StreamReader(WebRequest.Create(url).GetResponse().GetResponseStream())
        'Dim myWebRequest As WebRequest
        'myWebRequest = WebRequest.Create(url)
        'myWebRequest.Timeout = 5000
     
        ' Create a new WebClient instance.
        Dim myWebClient As New WebClient()
        myWebClient.Headers.Add(Net.HttpRequestHeader.UserAgent, ".Net client")  '2013-02-23 Fehlerbehebung Netzzugriff; nach http://www.vbdotnetforums.com/net-sockets/45516-getting-403-forbidden-error-valid-public-web-page.html

        Try
            ' Open a stream to point to the data stream coming from the Web resource.
            Dim myStream As Stream = myWebClient.OpenRead(url)
            Dim sr As New StreamReader(myStream)
            ' Close the stream.
            'myStream.Close() 'Darf man nicht, sonst sind die Daten weg
            '            sr = New StreamReader(myWebRequest.GetResponse().GetResponseStream())
            Fehler = False
            Return sr
        Catch ex As Exception
            MessageBox.Show("URL Kann nicht gelesen werden, Abbruch: " + url)
            Fehler = True
            ' Return sr
        End Try
    End Function

    Private Function getStreamFromFile(ByVal file As String) As StreamReader
        'Return New StreamReader(WebRequest.Create(url).GetResponse().GetResponseStream())
        Dim sr As StreamReader

        Try
            sr = New StreamReader(file)
            Return sr
        Catch ex As Exception
            MessageBox.Show("File Kann nicht gelesen werden, Abbruch: " + file)
            ' Return sr
        End Try
    End Function

    Private Function getStringFromURL(ByVal url As String, ByRef Fehler As Boolean) As String
        Return getStreamFromURL(url, Fehler).ReadToEnd()
    End Function

    Private Function readFileToArray(ByVal filename As String, ByVal length As Integer, ByVal counterfield As Integer, ByVal valuefield As Integer) As Double()
        Dim lines As String()
        Dim werte(length) As Double
        'If filename.Contains("PVL_B") Then
        '    werte(0) = 0 '$$$$
        'End If

        If (File.Exists(saveLocation.Text & filename)) Then
            filename = saveLocation.Text & filename
            lines = File.ReadAllLines(filename)
            Dim elements As String()
            Dim counter As Integer = 0
            Dim zeile As String
            If (counterfield = -1) Then
                zeile = lines(5)
                elements = zeile.Replace(" ", "").Split(";"c)
                counter = CInt(Val(elements(3)) * 12 + Val(elements(4)) / 5)
            End If
            For i As Integer = 0 To length : werte(i) = 0 : Next
            'Dim number As Integer
            For Each line In lines
                elements = line.Replace(" ", "").Split(";"c)
                If (counterfield = -1) Then
                    counter += 1
                Else
                    counter = CInt(Val(elements(counterfield)))
                End If
                If (elements.Length < valuefield + 1) Then Continue For
                If (elements(valuefield) = "") Then Continue For
                If (elements(valuefield) = "EinspeisunginkWh") Then Continue For
                If counter > 0 Then
                    werte(counter) = CDbl(elements(valuefield))
                End If
            Next
        Else
            werte(0) = 999999
        End If
        Return werte
    End Function

    Private Function readMinFileToArray(ByVal filename As String, ByVal length As Integer, ByVal counterfield As Integer, ByVal valuefield As Integer) As Double()
        Dim lines As String()
        Dim werte(length) As Double
        'If filename.Contains("PVL_B") Then
        '    werte(0) = 0 '$$$$
        'End If

        If (File.Exists(saveLocation.Text & filename)) Then
            filename = saveLocation.Text & filename
            lines = File.ReadAllLines(filename)
            Dim elements As String()
            Dim counter As Integer = 0
            ' Dim zeile As String
            If (counterfield = -1) Then
                'zeile = lines(5)
                'elements = zeile.Replace(" ", "").Split(";"c)
                'counter = CInt(Val(elements(3)) * 12 + Val(elements(4)) / 5)
                counter = -5
            End If
            For i As Integer = 0 To length : werte(i) = 0 : Next
            'Dim number As Integer
            For Each line In lines
                elements = line.Replace(" ", "").Split(";"c)
                If (counterfield = -1) Then
                    counter += 1
                Else
                    counter = CInt(Val(elements(counterfield)))
                End If
                If (elements.Length < valuefield + 1) Then Continue For
                If (elements(valuefield) = "") Then Continue For
                If (elements(valuefield) = "EinspeisunginkWh") Then Continue For
                If counter > 0 Then
                    werte(counter) = CDbl(elements(valuefield))
                End If
            Next
        Else
            werte(0) = 999999
        End If
        Return werte
    End Function

    Private Sub getFromPVLog(ByVal pvlID As Integer, ByVal pcID As Integer)
        Dim Fehler As Boolean
        Dim streamreader As StreamReader = getStreamFromURL("http://www.pv-log.com/Anlage/" & pvlID & ".php?File=days_hist.js", Fehler)
        Daten = ""
        Dim allLines As New List(Of String)
        While (Not streamreader.EndOfStream)
            allLines.Add(streamreader.ReadLine().Replace("da[dx++]=""", "").Replace("""", ""))
        End While
        allLines.Reverse()
        'MessageBox.Show(String.Join(Environment.NewLine, allLines.ToArray()))
        Dim elements As String()
        Dim filename As String
        Dim Monatswerte(13) As Double
        For i = 1 To 12
            Monatswerte(i) = 0
        Next i

        'Tagesfiles schreiben

        For Each line As String In allLines
            elements = line.Split(";"c, "."c, "|"c)
            filename = "PVL_" & pcID & "_" & elements(2).Trim() & "_" & CInt(elements(1)) & "_0_t.txt"
            File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
Solaranlage
--------------------------------------------------------------------------------------------------------
Tag; Monat; Jahr; Einspeisung in kWh
 
]]></a>.Value)
        Next
        For Each line As String In allLines
            elements = line.Split(";"c, "."c, "|"c)
            filename = "PVL_" & pcID & "_" & elements(2).Trim() & "_" & CInt(elements(1)) & "_0_t.txt"
            elements(3) = (CInt(elements(3)) / 1000).ToString()
            File.AppendAllText(saveLocation.Text & filename, String.Join("; ", elements) & Environment.NewLine)
        Next

        ' Monatsfiles schreiben

        '        For Each line As String In allLines
        '            elements = line.Split(";"c, "."c, "|"c)
        '            filename = "PVL_" & pcID & "_" & elements(2).Trim() & "_0_0_m.txt"
        '            Monatswerte(CInt(elements(2))) += (CInt(elements(3)) / 1000)
        '            File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
        'Solaranlage
        '--------------------------------------------------------------------------------------------------------
        'Monat; Jahr; Einspeisung in kWh

        ']]></a>.Value)
        '        Next
        '        For Each line As String In allLines
        '            elements = line.Split(";"c, "."c, "|"c)
        '            filename = "PVL_" & pcID & "_" & elements(2).Trim() & "_0_0_m.txt"
        '            elements(3) = Monatswerte(CInt(elements(2))).ToString
        '            File.AppendAllText(saveLocation.Text & filename, String.Join("; ", elements) & Environment.NewLine)
        '        Next



    End Sub


    Private Sub getFromFreeSol(ByVal FreeSolURL As String, ByVal pcID As Integer, ByVal TageswerteBerechnen As Boolean)
        Dim streamreader As StreamReader
        Dim elements As String()
        Dim Fehler As Boolean


        Try
            streamreader = getStreamFromURL(FreeSolURL, Fehler)
            Daten = ""
            Dim allLines As New List(Of String)
            While (Not streamreader.EndOfStream)
                allLines.Add(streamreader.ReadLine().Replace("da[dx++]=""", "").Replace("""", ""))
            End While
            allLines.Reverse()

            If TageswerteBerechnen Then
                Dim werte(allLines.Count, 3) As String
                For i = 0 To allLines.Count - 1
                    elements = allLines(i).Split(";"c)
                    werte(i, 1) = elements(0)
                    werte(i, 2) = elements(1)
                Next
                For i = 0 To allLines.Count - 1
                    If Val(werte(i, 2)) > Val(werte(i + 1, 2)) Then
                        werte(i + 1, 2) = CStr(0)
                    End If
                Next
                For i = 0 To allLines.Count - 2
                    If Val(werte(i, 2)) > 0 And Val(werte(i + 1, 2)) > 0 Then
                        werte(i + 1, 3) = ((Val(werte(i + 1, 2)) - Val(werte(i, 2))) / 10).ToString
                        allLines(i) = werte(i, 1) & ";" & werte(i + 1, 3)
                    Else
                        allLines(i) = werte(i, 1) & ";0"
                    End If
                Next
                allLines(allLines.Count - 1) = werte(allLines.Count - 1, 1) & ";0"
            End If
            'MessageBox.Show(String.Join(Environment.NewLine, allLines.ToArray()))
            Dim filename As String

            'Tagesfiles schreiben

            Dim Ltemp As Solaranlage
            '            If (yearBox.Text.ToString = "") Then Return
            Dim fileending = "_" & yearBox.Text.ToString & "_" & monthBox.Text.ToString & "_0_t.txt"

            DatenfileFehlt = True
            ReDim Ltemp.Tagesertrag(31)

            For i = 1 To 31
                Ltemp.Tagesertrag(i) = 0
            Next
            Ltemp.Tagesertrag = readFileToArray("FS_" & pcID & fileending, 32, 0, 3)


            For Each line As String In allLines
                elements = line.Split(";"c, "."c, "|"c)
                If Val(elements(1)) = Val(monthBox.Text) And Val(elements(2)) + 2000 = Val(yearBox.Text) Then
                    filename = "FS_" & pcID & "_20" & elements(2).Trim() & "_" & CInt(elements(1)) & "_0_t.txt"
                    File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
Solaranlage
--------------------------------------------------------------------------------------------------------
Tag; Monat; Jahr; Einspeisung in kWh
 
]]></a>.Value)
                End If
            Next
            For Each line As String In allLines
                elements = line.Split(";"c, "."c, "|"c)
                If Val(elements(1)) = Val(monthBox.Text) And Val(elements(2)) + 2000 = Val(yearBox.Text) Then
                    If CInt(elements(3)) > 0 Then
                        Ltemp.Tagesertrag(CInt(Val(elements(0)))) = CInt(elements(3)) / 1000
                    End If
                End If
            Next

            ReDim elements(4)
            For i = 1 To System.DateTime.DaysInMonth(CInt(Val(yearBox.Text)), CInt(Val(monthBox.Text)))
                filename = "FS_" & pcID & "_" & CInt(Val(yearBox.Text)) & "_" & CInt(Val(monthBox.Text)) & "_0_t.txt"

                elements(0) = i.ToString
                elements(1) = monthBox.Text
                elements(2) = yearBox.Text
                elements(3) = Ltemp.Tagesertrag(i).ToString

                File.AppendAllText(saveLocation.Text & filename, String.Join("; ", elements) & Environment.NewLine)
            Next

            ' Monatsfiles schreiben

            '        For Each line As String In allLines
            '            elements = line.Split(";"c, "."c, "|"c)
            '            filename = "PVL_" & pcID & "_" & elements(2).Trim() & "_0_0_m.txt"
            '            Monatswerte(CInt(elements(2))) += (CInt(elements(3)) / 1000)
            '            File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
            'Solaranlage
            '--------------------------------------------------------------------------------------------------------
            'Monat; Jahr; Einspeisung in kWh

            ']]></a>.Value)
            '        Next
            '        For Each line As String In allLines
            '            elements = line.Split(";"c, "."c, "|"c)
            '            filename = "PVL_" & pcID & "_" & elements(2).Trim() & "_0_0_m.txt"
            '            elements(3) = Monatswerte(CInt(elements(2))).ToString
            '            File.AppendAllText(saveLocation.Text & filename, String.Join("; ", elements) & Environment.NewLine)
            '        Next

        Catch ex As Exception

        End Try


    End Sub

    Private Sub getMinFromPVLog(ByVal pvlID As Integer, ByVal pcID As Integer)
        Dim Fehler As Boolean

        Dim streamreader As StreamReader = getStreamFromURL("http://www.pv-log.com/Anlage/" &
                                                            pvlID & ".php?File=min" &
                                                            yearBox.Text.Trim().Remove(0, 2) &
                                                            CInt(monthBox.Text).ToString("00") &
                                                            CInt(dayBox.Text).ToString("00") & ".js", Fehler)
        Daten = ""
        Dim allLines As New List(Of String)
        While (Not streamreader.EndOfStream)
            allLines.Add((streamreader.ReadLine().Split(""""c))(1).Replace(":00|", ";"))
        End While
        'MessageBox.Show(String.Join(Environment.NewLine, allLines.ToArray()))
        If (Not allLines.Count > 0) Then Return
        allLines.Reverse()
        Dim elements As String()
        elements = allLines(0).Split(";"c, "."c, "|"c, " "c, ":"c)
        Dim filename As String = "PVL_" & pcID & "_" & elements(2).Trim() & "_" & CInt(elements(1)) & "_" & CInt(elements(0)) & "_min.txt"
        File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
Solaranlage
--------------------------------------------------------------------------------------------------------
Tag; Monat; Jahr; Stunde; Minute; Einspeisung in kWh
 
]]></a>.Value)
        'irgendwie verschoben?
        Dim curTime As New Date(1995, 3, 1, 0, 0, 0)
        Dim lineTime As Date
        Dim lastValue As Double = 0
        For Each line As String In allLines
            elements = line.Split(";"c, "."c, "|"c, " "c, ":"c)
            lineTime = New Date(1995, 3, 1, CInt(elements(3)), CInt(elements(4)), 0)
            elements(5) = (CInt(elements(5)) / 1000 / 60).ToString()
            lastValue = CDbl(elements(5))
            curTime = lineTime
            File.AppendAllText(saveLocation.Text & filename, String.Join("; ", elements) & Environment.NewLine)
        Next
    End Sub

    Private Sub getMinFromFreeSol(ByVal FreeSolURL As String, ByVal pcID As Integer, ByVal Art As String)
        Dim Fehler As Boolean

        Dim streamreader As StreamReader = getStreamFromURL(FreeSolURL, Fehler)

        'Dim streamreader As New StreamReader(FreeSolURL)
        Daten = ""
        Dim allLines As New List(Of String)
        Dim datumszeile As String
        Dim datumsprefix As String
        If Fehler Then
            Exit Sub
        End If

        datumszeile = streamreader.ReadLine()
        While (Not streamreader.EndOfStream)
            allLines.Add(streamreader.ReadLine())
        End While
        If (Not allLines.Count > 0) Then Return
        Dim elements As String()
        elements = datumszeile.Split(";"c, "."c, "|"c, " "c, ":"c)
        Dim filename As String = "PVL_" & Art & "_" & pcID & "_20" & elements(2).Trim() & "_" & CInt(elements(1)) & "_" & CInt(elements(0)) & "_min.txt"
        datumsprefix = elements(2).Trim() + "; " + elements(1) + "; " + elements(0) + "; "
        File.WriteAllText(saveLocation.Text & filename, <a><![CDATA[Home
Solaranlage
--------------------------------------------------------------------------------------------------------
Tag; Monat; Jahr; Stunde; Minute; Einspeisung in kWh

]]></a>.Value)
        'irgendwie verschoben?
        Dim line As String
        If allLines.Count = 18 Then
            For j = 1 To 4
                allLines.Insert(0, "0: 0  0  0  0  0  0  0  0  0  0  0  0")
            Next
            For j = 1 To 2
                allLines.Insert(22, "0: 0  0  0  0  0  0  0  0  0  0  0  0")
            Next
        End If
        For j = 0 To 23
            line = allLines(j)
            line = line.Replace("  ", " ")
            line = line.Replace(": ", ":")
            line = Trim(line)
            elements = line.Split(";"c, "."c, "|"c, " "c, ":"c)
            For i = 1 To 11
                File.AppendAllText(saveLocation.Text & filename, datumsprefix + j.ToString + "; " + (i * 5).ToString + "; " + (CInt(elements(i)) * 12).ToString("#0.#####") & Environment.NewLine)
            Next
            File.AppendAllText(saveLocation.Text & filename, datumsprefix + (j + 1).ToString + "; " + (0).ToString + "; " + (CInt(elements(12)) * 12).ToString("#0.#####") & Environment.NewLine)
        Next
    End Sub

    Private Sub TB_L1Jahressollertrag_TextChanged(sender As System.Object, e As System.EventArgs) Handles TextBox1.TextChanged, TB_L1Jahressollertrag.TextChanged

    End Sub

    Private Sub CheckedListBox1_SelectedValueChanged(sender As System.Object, e As System.EventArgs) Handles CheckedListBox1.SelectedValueChanged
        MinutenwerteAnzeigen()
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        ' Tag und Vortag aktualisieren
        MinutenwerteVortagAktualisieren()
    End Sub



    Private Sub TabPage8_Click(sender As System.Object, e As System.EventArgs) Handles TabPage8.Enter
        MinutenvergleichAktualisieren()
    End Sub

    Private Sub Button3_Click_1(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        'alle Minutenwerte aus Portal aktualisieren
        If CheckBox8.Checked Then
            Dim dateiliste As New List(Of String)
            Dim remoteUri As String = TextBox13.Text
            Dim fileName As String
            Dim fileNameDir As String

            ' Directory lesen
            Dim myStringWebResource As String = Nothing
            Dim myWebClient As New WebClient()
            fileName = "directory.txt"
            myStringWebResource = remoteUri
            myWebClient.Headers.Add(Net.HttpRequestHeader.UserAgent, ".Net client") '2013-02-23 Fehlerbehebung Netzzugriff; nach http://www.vbdotnetforums.com/net-sockets/45516-getting-403-forbidden-error-valid-public-web-page.html
            myWebClient.DownloadFile(myStringWebResource, saveLocation.Text + fileName)
            statusBox.Text = "Directory lesen"

            Dim lines As String()
            Dim stringSeparators() As String = {"<a href="""}
            Dim counter As Integer = 0
            If (File.Exists(saveLocation.Text & "directory.txt")) Then
                fileNameDir = saveLocation.Text & "directory.txt"
                lines = File.ReadAllLines(fileNameDir)
                Dim elements As String()
                For Each line In lines
                    counter = counter + 1
                    elements = line.Split(stringSeparators, StringSplitOptions.None)
                    If elements.Length > 1 Then
                        elements = elements(1).Split(">"c, """"c)
                        If Not elements(0).Contains("?") And Not elements(0).Contains("/") Then
                            dateiliste.Add(elements(0))
                        End If
                    End If
                Next
            End If


            For Each fileName In dateiliste
                statusBox.Text = fileName
                statusBox.Refresh()
                ' hier lesen
                If fileName.Contains("minutesv.") Then
                    getMinFromFreeSol(remoteUri & fileName, PV1.PVLogNummer, "P")
                ElseIf fileName.Contains("_bv.js") Then
                    getMinFromFreeSol(remoteUri & fileName, PV2.PVLogNummer, "B")
                ElseIf fileName.Contains("_ev.js") Then
                    getMinFromFreeSol(remoteUri & fileName, PV3.PVLogNummer, "E")
                End If
            Next
            statusBox.Text = "Datenaktualisierung aus Portal fertig!"
        End If
    End Sub

    
    
End Class
